{$A+,B-,E-,F-,N-,O-,V-,I- }

{$IFDEF DEBUG }
  {$D+,L+,R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }
{$M $4000,0,$10000 } { 16Ko,0,64Ko }

program dtic;

uses Dos,RamDisk,VdtTools,Loading,VdtDisp,Emulato3;

type CfgRec = record
         ChChain    : string;    { chemin(s) de chainage }
         ChSave     : PathStr;   { chemin de sauvegarde du videotex }
         Ext        : string[3]; { extension videotex }
         EmulChain  : boolean;   { autorise ou non l'emulation des chainages }
         Emul       : EmulCfg;   { configuration de l'emulateur }
         Disp       : VDispCfg;  { configuration du compilateur }
         ModeAff    : byte;      { mode d'affichage }
         Inverse    : boolean;   { de droite  gauche }
         ZigZag     : boolean;
         ModMntel   : boolean;   { codes pour minitel }
       end;

     TpParam = record
         n : string[5];
         m : byte;   { 0=> rien 1=> Flip/Flop +-  2=paramtre }
       end;

const P_Rien = 0;
      P_Flip = 1;
      P_Egal = 2;

const Cfg : CfgRec = (
         ChChain    : '';
         ChSave     : '';
         Ext        : 'VDT';
         EmulChain  : TRUE;
         Emul       : (
           EmulTrans     : FALSE;
           VisuelConvert : TRUE;
           RTIC          : FALSE;
           InsLowOnly    : FALSE;
           C15Clr        : FALSE
           );
         Disp       : (
           CSI           : FALSE;    { (*) }
           OptInvGrp     : FALSE;
           OptInvTxt     : FALSE;
           OptRepet      : TRUE;     { (*) }
           xRep          : FALSE;
           ComplAsSpace  : FALSE;    { (*) }
           ForceDelGrp   : FALSE;
           ForceDelTxt   : FALSE;
           VideAsSpace   : FALSE;    { (*) }
           OptWithCan    : TRUE;
           OptSpclGrp    : FALSE;
           OptSpclTxt    : FALSE;
           C15Clr        : FALSE;
           OptMem        : 0;
           DebCursor     : FALSE;
           Scroll        : FALSE
           );
         ModeAff    : 0;             { (*) }
         Inverse    : FALSE;
         ZigZag     : FALSE;
         ModMntel   : FALSE
        );

      { * => la configuration du fichier DTI est celle par dfaut }

      CFGFileName : string[12] = 'DTIC.CFG';
      NbParam = 33;
      TabParam : array[1..NbParam] of TpParam = (
        ( n:'SV';   m:P_Egal ),  { /SV=   sauve }
        ( n:'CH';   m:P_Egal ),  { /CH=   chaine }
        ( n:'EX';   m:P_Egal ),  { /EX=   extension }
        ( n:'E';    m:P_Flip ),  { /E+-   active/desactive l'emulation des chainages }
        ( n:'ET';   m:P_Flip ),  { /ET+-  Emulation Transparence }
        ( n:'ER';   m:P_Flip ),  { /ER+-  Emulation RTIC }
        ( n:'EI';   m:P_Flip ),  { /EI+-  Emulation d'insertion du bas (M2) }
        ( n:'EC';   m:P_Flip ),  { /EC+-  Emulation effacement du soul latent si code #15 }
        ( n:'MM';   m:P_Flip ),  { /MM+-  ModMntel }
        ( n:'OIG';  m:P_Flip ),  { /OIG+- Opt. si Invisible en Graphik }
        ( n:'OIT';  m:P_Flip ),  { /OIT+- Opt. si invisible en Texte }
        ( n:'OR';   m:P_Flip ),  { /OR+-  Opt. les rpetitions }
        ( n:'ORX';  m:P_Flip ),  { /ORX+- Opt. les rpetitions en forme }
        ( n:'ORC';  m:P_Flip ),  { /ORC+- Opt. les rpetitions avec CAN }
        ( n:'OSG';  m:P_Flip ),  { /OSG+- Opt. speciale graphique }
        ( n:'OST';  m:P_Flip ),  { /OST+- Opt. speciale texte }
        ( n:'OST2'; m:P_Flip ),  { /OST2+- idem pour M2 }
        ( n:'OM';   m:P_Flip ),  { /OM+-  optimise si dj en Mem }
        ( n:'OMC';  m:P_Flip ),  { /OMC+- optimise constament si dj en Mem }
        ( n:'CSI';  m:P_Flip ),  { /CSI+- emploi des squences CSI }
        ( n:'CE';   m:P_Flip ),  { /CE+-  complement en espace }
        ( n:'VE';   m:P_Flip ),  { /VE+-  vide en espace }
        ( n:'FDG';  m:P_Flip ),  { /FDG+- force delimiteur graphique }
        ( n:'FDT';  m:P_Flip ),  { /FDT+- force delimiteur texte }
        ( n:'MHB';  m:P_Rien ),  { /MHB   mode affichage Haut bas }
        ( n:'MBH';  m:P_Rien ),  { /MBH   mode Bas haut }
        ( n:'MGD';  m:P_Rien ),  { /MGD   mode gauche  droite }
        ( n:'MDG';  m:P_Rien ),  { /MDG   mode droite  gauche }
        ( n:'MI';   m:P_Flip ),  { /MI+-  de droite  gauche }
        ( n:'MZZ';  m:P_Flip ),  { /MZZ+- en zigzag }
        ( n:'DC';   m:P_Flip ),  { /DC+-  debordement du curseur }
        ( n:'MRM';  m:P_Rien ),  { /MRM   rouleau montant }
        ( n:'MRD';  m:P_Rien )   { /MRD   rouleau descendant }
        );

      _SV   = 1;
      _CH   = 2;
      _EX   = 3;
      _E    = 4;
      _ET   = 5;
      _ER   = 6;
      _EI   = 7;
      _EC   = 8;
      _MM   = 9;
      _OIG  = 10;
      _OIT  = 11;
      _OR   = 12;
      _ORX  = 13;
      _ORC  = 14;
      _OSG  = 15;
      _OST  = 16;
      _OST2 = 17;
      _OM   = 18;
      _OMC  = 19;
      _CSI  = 20;
      _CE   = 21;
      _VE   = 22;
      _FDG  = 23;
      _FDT  = 24;
      _MHB  = 25;
      _MBH  = 26;
      _MGD  = 27;
      _MDG  = 28;
      _MI   = 29;
      _MZZ  = 30;
      _DC   = 31;
      _MRM  = 32;
      _MRD  = 33;

      M_HautBas      = 0;
      M_BasHaut      = 1;
      M_Montant      = 2;
      M_Descendant   = 3;
      M_GaucheDroite = 4;
      M_DroiteGauche = 5;


var Mem    : PMemPg_Rec;
    RDTI   : DirStr;
    NDTI   : NameStr;

function FileParam( var f : text ) : boolean;
var s : string;
    r : DirStr;
    n : NameStr;
    e : ExtStr;
begin
  FileParam := TRUE;

  { recherche d'abord dans le rpertoire courant }
  Assign(f,CFGFileName);
  reset(f);
  if IoResult=0 then exit;

  { recherche dans le rpertoire o est l'executable }
  s := ParamStr(0);
  if s<>'' then
    begin
      FSplit(s,r,n,e);
      Assign(f,r+CFGFileName);
      reset(f);
      if IoResult=0 then exit;
    end;

  { recherche dans le PATH dos }
  s := FSearch(CFGFileName,GetEnv('PATH'));
  if s<>'' then
    begin
      Assign(f,s);
      reset(f);
      if IoResult=0 then exit;
    end;

  FileParam := FALSE;
end;

function ChargeParam : boolean;
var f    : text;
    Disk : boolean;
    nPar : word;
    xPar : word;
    nLig : word;
    EndB : boolean;
    Lig  : string;

  procedure go;
  var n  : word;

    procedure Erreur( txt : string );
    begin
      if Disk then writeln(txt,'   n',nLig,'  param.n',n)
      else writeln(txt,'   param.n',xPar);
      EndB := TRUE;
    end;

    procedure DoIt( p : TpParam; Plus : boolean; var sp : string );
    var i : word;
    begin
    {  writeln(nLig:4,' ',n:4,' "',p.n,'" ',p.m,' ',Plus,' "',sp,'"'); }
      for i := 1 to length(p.n) do p.n[i] := UpCase(p.n[i]);
      for i := 1 to NbParam do
        if TabParam[i].n=p.n then
          begin
            if (TabParam[i].m<>p.m) And
               Not((p.m=P_Rien) And (TabParam[i].m=P_Flip)) then
              begin
                Erreur('Option mal utilise');
                exit;
              end;
            case i of
              _SV   :
                begin
                  Cfg.ChSave := sp;                    { /SV= }
                  if (Cfg.ChSave<>'') and
                     (Cfg.ChSave[length(Cfg.ChSave)]<>'\') then
                       begin
                         inc(Cfg.ChSave[0]);
                         Cfg.ChSave[length(Cfg.ChSave)] := '\';
                       end;
                end;
              _CH   : Cfg.ChChain := sp;                { /CH= }
              _EX   : Cfg.Ext := sp;                    { /EX= }
              _E    : Cfg.EmulChain := Plus;            { /E+- }
              _ET   : Cfg.Emul.EmulTrans := Plus;       { /ET+- }
              _ER   : Cfg.Emul.RTIC := Plus;            { /ER+- }
              _EI   : Cfg.Emul.InsLowOnly := Plus;      { /EI+- }
              _EC   : Cfg.Emul.C15Clr := Plus;          { /EC+- }
              _MM   : Cfg.ModMntel := Plus;             { /MM+- }
              _OIG  : Cfg.Disp.OptInvGrp := Plus;       { /OIG+- }
              _OIT  : Cfg.Disp.OptInvTxt := Plus;       { /OIT+- }
              _OR   : Cfg.Disp.OptRepet := Plus;        { /OR+- }
              _ORX  : Cfg.Disp.xRep := Plus;            { /ORX+- }
              _ORC  : Cfg.Disp.OptWithCan := Plus;      { /ORC+- }
              _OSG  : Cfg.Disp.OptSpclGrp := Plus;      { /OSG+- }
              _OST  : begin
                        Cfg.Disp.OptSpclTxt := Plus;    { /OST+- }
                        Cfg.Disp.C15Clr := FALSE;
                      end;
              _OST2 : begin
                        Cfg.Disp.OptSpclTxt := TRUE;
                        Cfg.Disp.C15Clr := Plus;        { /OST2+- }
                      end;
              _OM   : if Plus then Cfg.Disp.OptMem := 1 { /OM+- }
                      else Cfg.Disp.OptMem := 0;
              _OMC  : if Plus then Cfg.Disp.OptMem := 2 { /OMC+- }
                      else Cfg.Disp.OptMem := 1;
              _CSI  : Cfg.Disp.CSI := Plus;             { /CSI+- }
              _CE   : Cfg.Disp.ComplAsSpace := Plus;    { /CE+- }
              _VE   : Cfg.Disp.VideAsSpace := Plus;     { /VE+- }
              _FDG  : Cfg.Disp.ForceDelGrp := Plus;     { /FDG+- }
              _FDT  : Cfg.Disp.ForceDelTxt := Plus;     { /FDT+- }
              _MHB  : Cfg.ModeAff := M_HautBas;         { /MHB }
              _MBH  : Cfg.ModeAff := M_BasHaut;         { /MBH }
              _MGD  : Cfg.ModeAff := M_GaucheDroite;    { /MGD }
              _MDG  : Cfg.ModeAff := M_DroiteGauche;    { /MDG }
              _MI   : Cfg.Inverse := Plus;              { /MI+- }
              _MZZ  : Cfg.ZigZag := Plus;               { /MZZ+- }
              _DC   : Cfg.Disp.DebCursor := Plus;       { /DC+- }
              _MRM  : Cfg.ModeAff := M_Montant;         { /MRM }
              _MRD  : Cfg.ModeAff := M_Descendant;      { /MRD }
            else Erreur('Option hors service');
            end;
            exit;
          end;
      Erreur('Option inconnu');
    end;

  var is   : word;
      d    : string;
      v    : string;
      ir   : word;
      p    : TpParam;
      x    : word;
      e    : ExtStr;
  begin
    inc(nLig);
    is := 0;
    n  := 0;
    while not(EndB) and (is<length(Lig)) do
      begin
        d := '';
        inc(is);
        while (is<=length(Lig)) and (Lig[is]<>' ') do
          begin
            inc(d[0]);
            d[length(d)] := Lig[is];
            inc(is);
          end;

        ir := 1;
        while not(EndB) and (ir<=length(d)) do
          begin
            v := '';
            if (d[ir]='/') then
              begin
                v := '/';
                inc(ir);
              end
            Else
             If (d[ir]='-') Then
              Begin
               v := '-';
               Inc(ir);
              End;

            while (ir<=length(d)) and (d[ir]<>'/') And (d[ir]<>'-') do
              begin
                inc(v[0]);
                v[length(v)] := d[ir];
                inc(ir);
              end;

            if v<>'' then
              begin
                inc(n);
                inc(xPar);
                if (v[1]='/') Or (v[1]='-') then
                  begin
                    if v[length(v)]='+' then
                      begin
                        p.n  := copy(v,2,length(v)-2);
                        p.m  := P_Flip;
                        v    := '';
                        DoIt(p,TRUE,v);
                      end
                    else
                      if v[length(v)]='-' then
                        begin
                          p.n  := copy(v,2,length(v)-2);
                          p.m  := P_Flip;
                          v    := '';
                          DoIt(p,FALSE,v);
                        end
                      else
                        begin
                          x := Pos('=',v);
                          if x=0 then
                            begin
                              p.n := copy(v,2,length(v)-1);
                              p.m := P_Rien;
                              v   := '';
                              DoIt(p,TRUE,v);
                            end
                          else
                            begin
                              p.n := copy(v,2,x-2);
                              p.m := P_Egal;
                              v   := copy(v,x+1,255);
                              DoIt(p,FALSE,v);
                            end;
                        end;
                  end
                else
                  if (nPar=0) or (NDTI<>'') then Erreur('Syntaxe incorrecte')
                  else FSplit(v,RDTI,NDTI,e);
              end;
          end;
      end;
  end;

begin
  ChargeParam := FALSE;

  NDTI := '';

  Disk := FileParam(f);
  nPar := 0;
  xPar := 0;
  nLig := 0;

  EndB := FALSE;

  while not(EndB) do
    begin
      if Disk then
        begin
          if not(Eof(f)) then
            begin
              Readln(f,Lig);
              go;
            end;
          if Eof(f) then
            begin
              Close(f);
              Disk := FALSE;
              xPar := 0;
            end;
        end
      else
        begin
          if nPar<ParamCount then
            begin
              inc(nPar);
              Lig := ParamStr(nPar);
              go;
            end
          else
            begin
              EndB := TRUE;
              ChargeParam := TRUE;
            end;
        end;
    end;
  if Disk then Close(f);
end;

function ChargeDTI : boolean;
begin
  if NDTI<>'' then
    begin
      new(Mem);
      InitMemPg(Mem^);
      if LoadSingleMem(Mem^,RDTI+NDTI+'.DTI') then
        begin
          { reporter la configuration }

          If Cfg.ModeAff=255 Then
           Begin
            Case Mem^.Param.ModeAff Of
             0 : Cfg.ModeAff := M_HautBas;
             1 : Cfg.ModeAff := M_BasHaut;
             2 : Cfg.ModeAff := M_Montant;
             3 : Cfg.ModeAff := M_Descendant;
            Else
             Begin
              Writeln('Mode d''affichage inconnu !');
              ChargeDTI := FALSE;
              Exit;
             End;
            End;
           End;

          If Byte(Cfg.Disp.CSI)=255 Then Cfg.Disp.CSI := Mem^.Param.TypeM1B;
          If Byte(Cfg.Disp.VideAsSpace)=255 Then
            Cfg.Disp.VideAsSpace := not(Mem^.Param.SauteVide);
          If Byte(Cfg.Disp.ComplAsSpace)=255 Then
            Cfg.Disp.ComplAsSpace := Mem^.Param.ComplAsSpace;
          If Byte(Cfg.Disp.OptRepet)=255 Then
            Cfg.Disp.OptRepet := Mem^.Param.OptimiseRep;

          ChargeDTI := TRUE;
        end
      else
        begin
          writeln('Impossible de charger le fichier DTI');
          ChargeDTI := FALSE;
        end;
    end
  else
    begin
      writeln('Nom du fichier DTI manquant');
      ChargeDTI := FALSE;
    end;
end;


function TradString( var s : string ) : word;
{ traduit s en chaine, dans s }
{ renvoi 0 si la chaine est traduite, sinon, renvoi la position de l'erreur }
var lg : word;
    read : word;
    c  : char;
  function GetNumber : boolean;
  var x : byte;
  label la,la2,la3;
  begin
    GetNumber := FALSE;
    inc(read);
    if read>length(s) then exit;
    c := s[read];
    if (c>='0') and (c<='9') then
      begin
        x := 0;
        repeat
          x := x*10+(byte(c)-byte('0'));
          if x>127 then exit; { hors limite }
          inc(read);
          if (read>length(s)) then goto la;
          c := s[read];
        until (c<'0') or (c>'9');
la:     inc(lg);
        s[lg] := char(x);
        GetNumber := TRUE;
      end
    else
      if c='$' then
        begin { saisie Hexa }
          inc(read);
          if read>length(s) then exit;
          c := UpCase(s[read]);
          if ((c>='0') and (c<='9')) or ((c>='A') and (c<='F')) then
            begin
              x := 0;
              repeat
                if c>='A' then x := x*16+((byte(c)-byte('A'))+10)
                else x := x*16+(byte(c)-byte('0'));
                if x>127 then exit; { hors limite }
                inc(read);
                if read>length(s) then goto la2;
                c := s[read];
              until not(((c>='0') and (c<='9')) or ((c>='A') and (c<='F')));
la2:          inc(lg);
              s[lg] := char(x);
              GetNumber := TRUE;
            end
          else GetNumber := FALSE;
        end
      else
        if c='%' then
          begin { saisie binaire }
            inc(read);
            if read>length(s) then exit;
            c := UpCase(s[read]);
            if ((c>='0') and (c<='1')) then
              begin
                GetNumber := TRUE;
                x := 0;
                repeat
                  x := x*2+(byte(c)-byte('0'));
                  if x>127 then exit; { hors limite }
                  inc(read);
                  if read>length(s) then goto la3;
                  c := s[read];
                until not((c>='0') and (c<='1'));
la3:            inc(lg);
                s[lg] := char(x);
                GetNumber := TRUE;
              end
            else GetNumber := FALSE;
          end
        else GetNumber := FALSE;
  end;
  function GetChar : boolean;
  begin
    GetChar := FALSE;
    while (TRUE) do
      begin
        inc(read);
        if read>length(s) then exit;
        c := s[read];
        if c>#127 then
          begin
            GetChar := FALSE; { hors limite }
            exit;
          end;
        if c='''' then
          begin
            inc(read);
            if read>length(s) then
              begin
                GetChar := TRUE; { chaine complete }
                exit;
              end;
            c := s[read];
            if c='''' then
              begin
                inc(lg);
                s[lg] := '''';
              end
            else
              begin
                GetChar := TRUE;
                exit;
              end;
          end
        else
          begin
            inc(lg);
            s[lg] := char(c);
          end;
      end;
  end;
begin
  lg := 0;
  read := 1;
  while read<=length(s) do
    begin
      c := s[read];
      if c='#' then
        begin
          if not GetNumber then
            begin { erreur }
              TradString := read;
              exit;
            end;
        end
      else
        if c='''' then
          begin
            if not GetChar then
              begin
                TradString := read;
                exit;
              end;
          end
        else
          begin
            TradString := read;
            exit;
          end;
    end;
  { chaine complete }
  s[0] := char(lg);
  TradString := 0;
{  writeln('TradString="',s,'"'); }
end;

function EmpileFileInf(name : string ) : boolean;

  procedure GestFileError( io : word );
  begin
    writeln('Erreur disque n',io,' lors du chainage');
  end;

const Mx_lg = 1024;
type intermed_map = array[1..Mx_lg] of byte;
var io : word;
    intermed : ^intermed_map;
    result : word;
    f    : File;
    path : string;
begin
  EmpileFileInf := FALSE;

  new(intermed);

  if Pos('.',name)<=0 then name := name+'.'+Cfg.Ext;

  if name<>'' then
    begin
      path := FSearch(name,CFG.ChChain);
      if path='' then GestFileError(2)
      else
        begin
          assign(f,path);
          reset(f,1);
          io := ioresult;
          if io=0 then
            begin
              repeat
                BlockRead(f,intermed^,Mx_lg,result);
                MoveRam(intermed^,result);
              until result<Mx_lg;
              close(f);
              EmpileFileInf := TRUE;
            end
          else GestFileError(io);
        end;
    end
  else GestFileError(190);

  dispose(intermed);
end;

function EmpileChainInf(chainTxt : string) : boolean;
(* retourne true si tout c'est bien passe *)
var index : word;
    tempo : word;
    GoodStat : boolean;
    name : string[12];
begin
  GoodStat := true;
  index := 1;
  while (index<=length(chainTxt)) and GoodStat do
    begin
      tempo := Pos('+',ChainTxt);
      if tempo<=0 then tempo := length(ChainTxt)+1
      else ChainTxt[tempo] := '\';
      name := copy(ChainTxt,index,tempo-index);
      GoodStat := EmpileFileInf(name);
      index := tempo+1;
    end;
  EmpileChainInf := GoodStat;
end;

function MakeIntro( var M : MemPg_Rec ) : boolean;
(* retourne si les operations de chainage ce sont bien produite *)
var status : boolean;
    t      : string;
begin
  if M.param.LongChain<>0 then status := EmpileChainInf(M.Chain)
  else status := true;
  if status then
    begin
      { introduire le code 1 !!! }
      t := M.Code1;
      if TradString(t)=0 then MoveRam(t[1],length(t)); { envoi le code... }
      if M.param.IntroCur<>0 then
        if M.Param.IntroCur=1 then PutRam(17) else PutRam(20);
      if M.Param.VideLnZero then WriteRam(#31'@A'#24#10);
      if M.Param.VideEcran then PutRam(12);
    end;
  MakeIntro := status;
end;

procedure MakeConclu( var M : MemPg_Rec );
  procedure EnCommun;
  begin
    if (M.param.PPanel and 7)<>7 then
      begin
        WriteRam(#27+char(64+CoulPC[M.param.PPanel and 7]));
      end;
    if (M.param.PPanel and 512)=0 then WriteRam(#27#72);
  end;
var t : string;
begin
  with M.param do
    begin
      if PlaceCur then
        begin
          WriteRam(#31+char(65+PLigne)+char(65+PColonne));
          if (PPanel and MskGraphik)=0 then
            begin (* texte *)
  EnCommun;
  if (PPanel and 192)<>0 then WriteRam(#27+char(76+((PPanel shr 6) and 3)));
  if (PPanel and 256)<>0 then WriteRam(#27#93);
            end
          else
            begin (* graphik *)
  PutRam(14);
  EnCommun;
  if (PPanel and 56)<>0 then
    WriteRam(#27+char(80+CoulPC[(PPanel shr 3) and 7]));
  if (PPanel and 1024)<>0 then WriteRam(#27#90);
            end;
        end;
      if ConcluCur<>0 then
        if ConcluCur = 1 then PutRam(17) else PutRam(20);
      { introduire le code 2 !!! }
      t := M.Code2;
      if TradString(t)=0 then MoveRam(t[1],length(t)); { envoi le code... }
    end;
end;


Procedure StartRouleau( Var VD : VDispRec );
Begin
 If Cfg.ModMntel Then WriteRam(#27#$3A+'f'+Char(4));
 WriteRam(#27#$3A+#$69+#$43);
 VD.Cfg.DebCursor := FALSE;
 VD.Cfg.Scroll    := TRUE;
End;


Procedure StopRouleau( Var VD : VDispRec );
Begin
 If Cfg.ModMntel Then WriteRam(#27#$3A+'f'+Char(4));
 WriteRam(#27#$3A+#$6A+#$43);

 VD.Cfg.Scroll    := FALSE;
End;


function Compil : boolean;
var s : string;
    pos : word;
    VD  : VDispRec;
    Ram : PVDispRam;
    Em  : EmulRec;
    i   : word;
    Inverse : boolean;
    RolOn   : Boolean;

  procedure Trans(xi, yi : word);
  var pos : word;
  begin
    pos := xi+40*(yi-1);
    TransCode(VD,xi,yi,char(Mem^.Show[pos].Data),Mem^.Show[pos].Att,s);
    if s<>'' then WriteRam(s);
  end;

  procedure TransX( yi : word );
  var xi : word;
  begin
    if Inverse then
      for xi := 39 downto 0 do Trans(xi,yi)
    else for xi := 0 to 39 do Trans(xi,yi);
    if Cfg.ZigZag then Inverse := not(Inverse);
  end;

  procedure TransY( xi : word );
  var yi : word;
  begin
    if Inverse then
      for yi := 24 downto 1 do Trans(xi,yi)
    else for yi := 1 to 24 do Trans(xi,yi);
    if Cfg.ZigZag then Inverse := not(Inverse);
  end;

  procedure TransScrollUp(xi, yi : word);
  var pos : word;
  begin
    pos := xi+40*(yi-1);
    TransCode(VD,xi,24,char(Mem^.Show[pos].Data),Mem^.Show[pos].Att,s);
    If s<>'' then WriteRam(s);
  end;

  Procedure TransScrollUpX( yi : Word );
  Var xi : Word;
  Begin
   If RolOn Then
    Begin
     If Not(VD.NextLn) Then
      Begin
       TransCodeScrollUp(VD,s);
       If s<>'' Then WriteRam(s);
      End;
    End
   Else RolOn := TRUE;

   If Inverse Then
    For xi := 39 Downto 0 Do TransScrollUp(xi,yi)
   Else For xi := 0 to 39 do TransScrollUp(xi,yi);

   If Cfg.ZigZag Then Inverse := not(Inverse);
  End;

  procedure TransScrollDown(xi, yi : word);
  var pos : word;
  begin
    pos := xi+40*(yi-1);
    TransCode(VD,xi,1,char(Mem^.Show[pos].Data),Mem^.Show[pos].Att,s);
    If s<>'' then WriteRam(s);
  end;

  Procedure TransScrollDownX( yi : Word );
  Var xi : Word;
  Begin
   If RolOn Then
    Begin
     If VD.NextLn Then
      Begin
       TransCodeScrollDown(VD,s);
       If s<>'' Then WriteRam(s);
      End;
     TransCodeScrollDown(VD,s);
     If s<>'' Then WriteRam(s);
    End
   Else RolOn := TRUE;

   If Inverse Then
    For xi := 39 Downto 0 Do TransScrollDown(xi,yi)
   Else For xi := 0 to 39 do TransScrollDown(xi,yi);

   If Cfg.ZigZag Then Inverse := not(Inverse);
  End;

var xi, yi : word;
begin
  if MakeIntro(Mem^) then
    begin
      new(Ram);
      ClearRam(Ram);

      VD.Ram := Ram;
      InitVD(VD);
      VD.Cfg := Cfg.Disp;

      if Cfg.EmulChain then
        begin
          { on emule l'introduction }
          Em.Ram := Ram;
          InitEmul(Em);
          Em.Cfg := Cfg.Emul;
          ResetGetRam;
          for i := 1 to LongRam do Emul(Em,char(GetRam));

          VD.Cur.X   := Em.Stat.X;
          VD.Cur.Y   := Em.Stat.Y;
          VD.Cur.Att := Em.Stat.Att;
          VD.Cur.Rdy := TRUE;
        end;

      Inverse := Cfg.Inverse;
      RolOn   := Not(Mem^.Param.VideEcran);

      case Cfg.ModeAff of
        M_BasHaut :
          for yi := 24 downto 1 do TransX(yi);
        M_Montant      :
         Begin
          StartRouleau(VD);
          For yi := 1 To 24 Do TransScrollUpX(yi);
          StopRouleau(VD);
         End;

        M_Descendant   :
         Begin
          StartRouleau(VD);
          For yi := 24 Downto 1 Do TransScrollDownX(yi);
          StopRouleau(VD);
         End;

        M_GaucheDroite :
          for xi := 0 to 39 do TransY(xi);
        M_DroiteGauche :
          for xi := 39 downto 0 do TransY(xi);
      else { M_HautBas }
        for yi := 1 to 24 do TransX(yi);
      end;

      FlushTrans(VD,s);
      WriteRam(s);

      MakeConclu(Mem^);
      Compil := TRUE;
      dispose(Ram);
    end
  else Compil := FALSE;
end;

function SauveCompil : boolean;
(* indique en sortie si l'operation c'est bien passe *)
var f  : File;
    io : word;
  procedure go;
  const Mx_lg = 1024;
  type intermed_map = array[1..Mx_lg] of byte;
  var  result   : word;
      intermed : ^intermed_map;
  begin
    rewrite(f,1);
    io := ioresult;
    if io=0 then
      begin
        new(intermed);

        ResetGetRam;

        repeat
          ReadRam(intermed^,sizeof(intermed^),result);
          if result>0 then BlockWrite(f,intermed^,result,result);
        until result=0;

        dispose(intermed);
        close(f);
        SauveCompil := TRUE;
      end
    else
      begin
        writeln('Disque erreur n',io);
        SauveCompil := FALSE;
      end;
  end;
var ExLg  : word;
    CrrLg : word;
    s     : string;
    x     : longint;
    i     : word;
begin
  CrrLg := LongRam;
  s := Cfg.ChSave+NDTI+'.'+Cfg.Ext;
  for i := 1 to length(s) do s[i] := UpCase(s[i]);
  write(CrrLg,' codes (',CrrLg/120:0:2,'s) dans ''',s,'''');
  assign(f,s);
  reset(f,1);
  io := IoResult;
  if io=0 then
    begin
      ExLg := FileSize(f);
      x := longint(CrrLg)-ExLg;
      if x>0 then write('  (+',x,') ... ')
      else write('  (',x,') ... ');
    end
  else write(' ... ');
  go;
end;


procedure ClrLine;
var i : word;
begin
  write(#13);
  for i := 1 to 79 do write(' ');
  write(#13);
end;


Procedure Pause;
Begin
 Write('Appuyez une touche pour continuer ... ');
 Asm
 @RELIT:
     MOV  AH, 08h
     INT  21h
     OR   AL, AL
     JZ   @RELIT
 End;
 ClrLine;
End;


begin
  writeln('DTIC v1.2  par T.Jaouen  (C) 1991');
  if ParamCount>0 then
    begin
      Byte(Cfg.Disp.CSI) := 255;
      Byte(Cfg.Disp.OptRepet) := 255;
      Byte(Cfg.Disp.ComplAsSpace) := 255;
      Byte(Cfg.Disp.VideAsSpace) := 255;
      Cfg.ModeAff := 255;

      if ChargeParam and ChargeDTI then
        begin
          OpenRam;
          if Compil then if SauveCompil then writeln('Ok.');
          CloseRam;
        end;
    end
  else
    begin
      writeln('Usage: DTIC [options] nom_de_fichier [options]');
      writeln(' Options|df.|fonctions');
      writeln(' -------|---|---------');
      writeln(' /SV=        Chemin de destination du fichier videotex');
      writeln(' /CH=        Chemin(s) de recherche des fichiers  chainer');
      writeln(' /EX=    VDT Extension attribue aux fichiers videotex');
      writeln(' /E+-     +  Active ou non l''mulation des chainages');
      writeln(' /ET+-    -  Emulation du mode "Transparence"');
      writeln(' /ER+-    ?  Emulation M1B modle RTIC');
      writeln(' /EI+-    -  Emulation d''insertion du bas (M2)');
      writeln(' /EC+-    -  Emulation avec adaptation au bogue de soulignement (M2)');
      writeln(' /MM+-    -  Produit un code adapt au modem du minitel (inutilis)');
      writeln(' /OIG+-   -  Optimise si effet invisible en mode graphique (*)');
      writeln(' /OIT+-   -  Optimise si effet invisible en mode texte (*)');
      writeln(' /OR+-    ?  Optimise les rpetitions de caractres');
      writeln(' /ORX+-   -  Optimise les rpetitions de faon standardis');
      writeln(' /ORC+-   +  Optimise les rpetitions aussi avec le code CAN');
      writeln(' /OSG+-   -  Optimisation speciale en mode graphique');
      writeln(' /OST+-   -  Optimisation speciale en mode texte');
      writeln(' /OST2+-  -  Optimisation speciale em mode texte pour M2');
      writeln(' /OM+-    -  Optimise si dj en mmoire sauf pour les rptitions (*)');
      writeln(' /OMC+-   -  Optimise si dj en mmoire (*)');
      writeln(' /CSI+-   ?  Optimise avec des squences CSI (M1B et suprieur)');
      Pause;
      writeln(' /CE+-    ?  Complements assimils  des espace');
      writeln(' /VE+-    ?  Vides assimils  des espaces');
      writeln(' /FDG+-   -  Force l''criture des dlimiteurs en mode graphique');
      writeln(' /FDT+-   -  Force l''criture des dlimiteurs en mode texte');
      writeln(' /MHB     ?  Mode d''affichage de "Haut en Bas"');
      writeln(' /MBH     ?  Mode d''affichage de "Bas en Haut"');
      Writeln(' /MRM     ?  Mode d''affichage "Rouleau Montant"');
      Writeln(' /MRD     ?  Mode d''affichage "Rouleau Descendant"');
      writeln(' /MGD        Mode d''affichage de "Gauche  Droite"');
      writeln(' /MDG        Mode d''affichage de "Droite  Gauche"');
      writeln(' /MI+-    -  Inversion du sens d''affichage');
      writeln(' /MZZ+-   -  Effet d''affichage en zigzag');
      writeln(' /DC+-    -  Debordement du Curseur');
      writeln;
      writeln(' (*): Optimisation aux rsultats variables suivant les cas.');
      writeln('  ? : Prend par dfaut l''tat dfini dans le fichier DTI.');
      writeln;
      writeln(' Ces options peuvent tre regroupes dans un fichier texte "DTIC.CFG".');
      writeln;
      writeln(' Exemple:  DTIC /OSG+ /ORX+ /CSI+ monfichier /EX=VDX');
      writeln;
    end;
end.
