{$A+,B-,E-,F-,N-,O-,V-,I- }

{$IFDEF DEBUG }
  {$D+,L+,R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit Emulato3;

Interface
uses {$IFDEF ToScreen }
     Video2,Colors,
     {$ENDIF }
     VdtTools,VdtDisp;


const ScreenLong = 40;
      ScreenHigh = 25;  { ligne 0 speciale }

      LongPCode = 10;

      CoulPC : array[0..7] of byte = (0,2,4,6,1,3,5,7);

type EmulCfg = record
         EmulTrans     : boolean;  { Emulation des transparences }
         VisuelConvert : boolean;  { Conversion visuelle pour pc }
         {$IFDEF ToScreen }
         ToScreen      : boolean;  { Transposition  l'ecran     }
         ShowCur       : boolean;  { montre les mouvements du curseur }
         SX,SY         : byte;     { coord o ecrire  l'ecran   }
         {$ENDIF }
         RTIC          : boolean;  { M1B de type RTIC ?          }
         InsLowOnly    : boolean;  { en insertion, le bas bouge seulement (M2) }
         C15Clr        : boolean;  { si le code 15 annule le soul latent (M2) }
       end;

     EmulStat = record
         LastCar    : char;     { dernier caractre reu }
         MdIns      : boolean;  { mode insertion en criture }
         MdPage     : boolean;  { mode page ( sinon rouleau ) }
         CurON      : boolean;  { etat du curseur allum ? }
         X,Y        : byte;     { coord du curseur (0..39,0..24) }
         Att        : word;     { attribut courant du curseur }
         Latent     : word;     { attribut latent du curseur (dlimiteur) }
       end;

     EmulSave = record
         Use        : boolean;
         X,Y        : byte;
         Att        : word;
         Latent     : word;
       end;

     EmulAiguillage = (NUL,REP,SEP,SS2,SS2_M,SS3,US,ESC,FILT,
                       PRO1,PRO2,PRO3,ISO_6429,ISO_2022,TRANS_MODE);

type PRO_Rec = record
         Par1, Par2, Par3 : word;               { parametre aiguillage }
         PCode : array[0..LongPCode-1] of byte; { parametre videotex }
       end;

     EmulRec = record
         Aig   : EmulAiguillage; { aiguillage }
         Cfg   : EmulCfg;
         Stat  : EmulStat;
         Save  : EmulSave;
         Ram   : PVDispRam;
         Pro   : PRO_Rec;
       end;

procedure InitEmul( var Em : EmulRec );
procedure SetDefaultEmul( var Cfg : EmulCfg );
procedure Emul( var Em : EmulRec; Car : char );


implementation



const DefaultCfg : EmulCfg = (
          EmulTrans     : TRUE;    { Emulation des transparences }
          VisuelConvert : TRUE;    { Conversion visuelle pour pc }
          {$IFDEF ToScreen }
          ToScreen      : FALSE;   { Transposition  l'ecran     }
          ShowCur       : FALSE;
          SX            : 0;       { coord o ecrire  l'ecran   }
          SY            : 0;
          {$ENDIF }
          RTIC          : TRUE;    { M1B de type RTIC ?          }
          InsLowOnly    : FALSE;   { car M1B                     }
          C15Clr        : FALSE    { car emulateur M1B ...       }
        );

const Trait      = 7;
      Fond       = 56;
      Taille     = 192;
      Inverse    = 256;
      Stable     = 512;
      Disjoint   = 1024;
      Souligne   = 1024;
      Mask       = 2048;

      Graphik    = 8192;

      Delim      = 32768;

      Complement = 176;
      Haut       = 64;
      Large      = 128;

      AttNothing = Trait+Stable+Graphik;
      AttInit    = Trait+Stable;


      CarError     = 168;
      CarErrorM1B  = 127;



const { #25#x -> IBM o x<>65,66,67,72,75 }
      TabExt : array[32..127] of char =
        ('_','_','_','','$','_','#',#21,'_','_','_','_',#27,#24,#26,#25,
         '','','_','_','_','_','_','_','','_','_','_','','','','_',
         '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
         '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
         '_','_','_','_','_','_','_','_','_','_','','_','_','_','_','_',
         '_','_','_','_','_','_','_','_','_','_','','','_','_','_','_');

      TabAccent_A : array[65..72] of char = ('','a','','a','a','a','a','');
      TabAccent_E : array[65..72] of char = ('','','','e','e','e','e','');
      TabAccent_I : array[65..72] of char = ('i','i','','i','i','i','i','');
      TabAccent_O : array[65..72] of char = ('o','o','','o','o','o','o','');
      TabAccent_U : array[65..72] of char = ('','u','','u','u','u','u','');

function TraducteurTwo( CarOne, Car : char ) : char;
{ attention: dataOne=[65..72] ou 75 sinon ca plante! }
begin
  if CarOne=#75 then
    begin
      if Car='c' then Car := ''
      else if Car='C' then Car := '';
    end
  else
    case Car of
      'a' : Car := TabAccent_A[byte(CarOne)];
      'e' : Car := TabAccent_E[byte(CarOne)];
      'i' : Car := TabAccent_I[byte(CarOne)];
      'o' : Car := TabAccent_O[byte(CarOne)];
      'u' : Car := TabAccent_U[byte(CarOne)];
    end;
  TraducteurTwo := Car;
end;

{$IFDEF ToScreen }

procedure CurChange( var Em : EmulRec );
begin
  if Em.Cfg.ToScreen and Em.Cfg.ShowCur then
    begin
      CurXY(Em.Cfg.SX+Em.Stat.X,Em.Cfg.SY+Em.Stat.Y);
    end;
end;

procedure ScrChange;
begin
end;


{ ------------------------------------------------------------ }

procedure AffMntlLigne( var Em : EmulRec; Line,x1,x2: byte);
var i     : word;
    c     : VDispRamEl;
    Ram   : PVDispRam;
    data  : byte;
    att   : byte;
begin
  Ram := Em.Ram;
  for i := x1 to x2 do
    begin
      c := Ram^[Line,i];
      if c.Car=#0 then
        begin
          data := RIEN;
          att  := CRien;
        end
      else
        if (c.Att and Graphik)=0 then
          begin
            data := byte(c.Car);
            att  := CTout;
          end
        else
          begin
            data := CarGraphik;
            att  := CTout;
          end;
      WrtDt(data,Em.Cfg.SX+i,Em.Cfg.SY+Line,att)
    end;
end;

procedure AffMntl( var Em : EmulRec; ligneStart : byte );
var ligne : byte;
begin
  for ligne:= ligneStart to ScreenHigh-1 do
    AffMntlLigne(Em,ligne,0,ScreenLong-1);
end;

procedure AffLigneVide( var Em : EmulRec; ligne,X1,X2 : byte);
var Zn : Zn_Rec;
begin
  Zn.X  := Em.Cfg.SX+X1;
  Zn.Lg := (X2+1)-X1;
  Zn.Ht := 1;
  Zn.Y  := Em.Cfg.SY+ligne;
  FillZn(Zn,RIEN,CRien);
end;

{$ENDIF }

procedure ScrUp( var Em : EmulRec; Y : byte ); { monte l'ecran }
{ Y de 1..24 ( pas 0 ! ) }
var Ram : PVDispRam;
    i   : word;
    {$IFDEF ToScreen }
    Zn  : Zn_Rec;
    {$ENDIF }
begin
  if (Y>0) and (Y<ScreenHigh-1) then
    begin
      Ram := Em.Ram;
      move(Ram^[Y+1],Ram^[Y],sizeof(Ram^[0])*(ScreenHigh-(Y+1))); { +1 ... }
      for i := 0 to ScreenLong-1 do
        with Ram^[ScreenHigh-1,i] do
          begin
            Car := #0;
            Att := AttNothing;
          end;
      {$IFDEF ToScreen }
      if Em.Cfg.ToScreen then
        begin
          Zn.X  := Em.Cfg.SX;
          Zn.Y  := Em.Cfg.SY+Y;
          Zn.Lg := ScreenLong;
          Zn.Ht := ScreenHigh-Y;
          ZnUp(Zn,1,0);
          AffLigneVide(Em,ScreenHigh-1,0,ScreenLong-1)
        end;
      {$ENDIF }
    end;
end;

procedure ScrDown( var Em : EmulRec; Y : byte ); { descend l'ecran }
{ Y de 1..24 ( pas 0 ! ) }
var Ram : PVDispRam;
    i   : word;
    {$IFDEF ToScreen }
    Zn  : Zn_Rec;
    {$ENDIF }
begin
  if (Y>0) and (Y<ScreenHigh-1) then
    begin
      Ram := Em.Ram;
      move(Ram^[Y],Ram^[Y+1],sizeof(Ram^[0])*(ScreenHigh-(Y+1))); { +1 ... }
      for i := 0 to ScreenLong-1 do
        with Ram^[Y,i] do
          begin
            Car := #0;
            Att := AttNothing;
          end;
      {$IFDEF ToScreen }
      if Em.Cfg.ToScreen then
        begin
          Zn.X  := Em.Cfg.SX;
          Zn.Y  := Em.Cfg.SY+Y;
          Zn.Lg := ScreenLong;
          Zn.Ht := ScreenHigh-Y;
          ZnDn(Zn,1,0);
          AffLigneVide(Em,Y,0,ScreenLong-1);
        end;
      {$ENDIF }
    end;
end;

procedure ClrLigneMntl( var Em : EmulRec; Y, Xstart, Lim : byte);
var i   : word;
    Ram : PVDispRam;
begin
  Ram := Em.Ram;
  for i := XStart+1 to Lim do
    with Ram^[Y,i] do
      begin
        Car := #0;
        Att := AttNothing;
      end;
  InRam(Ram,XStart,Y,#0,AttNothing);
  {$IFDEF ToScreen }
  if Em.Cfg.ToScreen then AffLigneVide(Em,Y,XStart,Lim);
  {$ENDIF }
end;

procedure ClrScrMntl( var Em : EmulRec; Y, Lim : byte );
var i : word;
begin
  for i := Y to Lim do ClrLigneMntl(Em,i,0,ScreenLong-1);
end;

procedure SupMntl( var Em : EmulRec; X, Y, Nbre : byte);
var Ram : PVDispRam;
    i   : word;
begin
  if X+Nbre<ScreenLong then
    begin
      Ram := Em.Ram;
      for i := X+Nbre to ScreenLong-1 do
        InRam(Ram,i-Nbre,Y,Ram^[Y,i].Car,Ram^[Y,i].Att);
      {$IFDEF ToScreen }
      if Em.Cfg.ToScreen then AffMntlLigne(Em,Y,X,ScreenLong-1-Nbre);
      {$ENDIF }
      X := ScreenLong-Nbre;
    end;
  ClrLigneMntl(Em,Y,X,ScreenLong-1) { toutes la ligne a partir de X y passe ! }
end;

procedure InsMntl( var Em : EmulRec; X, Y, Nbre : byte );
var Ram : PVDispRam;
    i   : word;
begin
  if (X+Nbre)<ScreenLong then
    begin
      Ram := Em.Ram;
      move(Ram^[Y,X],Ram^[Y,X+Nbre],(ScreenLong-(X+Nbre))*sizeof(Ram^[0,0]));
      {$IFDEF ToScreen }
      if Em.Cfg.ToScreen then AffMntlLigne(Em,Y,X+Nbre,ScreenLong-1);
      {$ENDIF }
    end
  else Nbre := 40-x;
  ClrLigneMntl(Em,Y,X,(X+Nbre)-1);
end;

{ ---------------------------------------------------------------- }

procedure SetDefaultEmul( var Cfg : EmulCfg );
begin
  Cfg := DefaultCfg;
end;

const DefaultStat : EmulStat = (
          LastCar : #0;
          MdIns   : FALSE;
          MdPage  : TRUE;
          CurON   : FALSE;
          X       : 0;
          Y       : 1;
          Att     : AttInit;
          Latent  : 0
        );

procedure InitEmul( var Em : EmulRec );
var Ram : PVDispRam;
begin
  Ram := Em.Ram;  { sauve }
  FillChar(Em,sizeof(Em),0);
  Em.Cfg  := DefaultCfg;
  Em.Ram  := Ram;
  EM.Stat := DefaultStat;
  EM.Aig  := NUL;
end;

{$IFDEF ToScreen }
procedure Ecrit_C( var Em : EmulRec );
begin
  if Em.Cfg.ToScreen then
    begin
      WrtDt(byte(' '),Em.Cfg.SX+36,Em.Cfg.SY,CRien);
      WrtDt(byte(' '),Em.Cfg.SX+37,Em.Cfg.SY,CRien);
      WrtDt(byte('C'),Em.Cfg.SX+38,Em.Cfg.SY,$70);
    end;
end;
{$ENDIF }

procedure CurHome( var Em : EmulRec ); { code 12 ou 30 }
begin
  Em.Stat.X      := 0;
  Em.Stat.Y      := 1;
  Em.Stat.Att    := AttInit;
  Em.Stat.Latent := 0;
  Em.Save.Use    := FALSE;
  {$IFDEF ToScreen }
  Ecrit_C(Em);
  CurChange(Em);
  {$ENDIF }
end;



function CorrigeCar( var Em : EmulRec; Car : char; Att : word ) : char;
begin
  { corrige Car }
  if Att and Graphik=0 then
    begin { texte }
      if Em.Cfg.VisuelConvert then
        case Car of
           #96 : Car := #196;
          #124 : Car := #179;
        end;
    end
  else
    begin { graphik }
      if (Car>=#64) and (Car<=#94) then inc(Car,32)
      else if Car=#127 then Car := #95;
    end;
  CorrigeCar := Car;
end;

procedure PropAtt( Y : byte;
                   Car : char; var Att, Latent : word;
                   PrecAtt : word; CanBeDelim : boolean );
begin
  if Att and Graphik=0 then
    begin { mode texte }
      if CanBeDelim and (Car=#32) and (Latent<>0) then
        begin { en texte, qu'un seul est latent, et tous le deviennent }
          Att := Att or Delim;
          Latent := 0;
        end
      else
        Att := (Att and not(Fond+Souligne+Mask+Delim)) or
               (PrecAtt and (Fond+Souligne+Mask));
    end
  else
    begin { mode graphik }
      if CanBeDelim and (Car=#32) and (Latent and Mask<>0) then
        begin
          Att := Att or Delim;
          Latent := 0;
        end
      else
        begin
          Att := (Att and not(Mask+Delim)) or (PrecAtt and Mask);
          Latent := Latent and not(Fond+Souligne);
        end;
    end;
  if (Y<=1) and
     (Att and Taille=Taille) then Att := Att and not(Taille);
end;

{$IFDEF ToScreen }
procedure ToScreen( var Em : EmulRec; X, Y : byte; Car : char; Att : word );
var cX, cY : word;
begin
  cX := Em.Cfg.SX+X;
  cY := Em.Cfg.SY+Y;
  if Att and Graphik=0 then
    begin
      WrtDt(byte(Car),cX,cY,CTout);
      if (Y>1) and (Att and Haut<>0) then
        begin
          WrtDt(Complement,cX,cY-1,CTout);
          if (X<ScreenLong-1) and (Att and Large<>0) then
              WrtDt(Complement,cX+1,cY-1,CTout);
        end;
      if (X<ScreenLong-1) and (Att and Large<>0) then
          WrtDt(Complement,cX+1,cY,CTout);
    end
  else WrtDt(CarGraphik,cX,cY,CTout);
end;
{$ENDIF }

procedure CurMove( var Em : EmulRec; var X, Y : byte; Att : word );
begin
  { deplace le curseur ... }
  if Att and Large<>0 then inc(X,2)
  else inc(X);
  if X>ScreenLong-1 then
    if Y>0 then
      begin
         X := 0;
         if Att and Haut<>0 then
           begin
             inc(Y,2);
             if Y>ScreenHigh-1 then
               if Em.Stat.MdPage then Y := 2
               else
                 begin
                   ScrUp(Em,1);
                   if Y>ScreenHigh then ScrUp(Em,1);
                   Y := ScreenHigh-1;
                 end;
           end
         else
           begin
             inc(Y);
             if Y>ScreenHigh-1 then
               if Em.Stat.MdPage then Y := 1
               else
                 begin
                   ScrUp(Em,1);
                   Y := ScreenHigh-1;
                 end;
           end;
      end
    else X := ScreenLong-1; { dbordement impossible en ligne 0 }
end;

procedure InsertAtt( var Em : EmulRec; X, Y : byte; Att : word );
begin
  if (Att and Haut<>0) and (Y>1) and (Em.Cfg.InsLowOnly=FALSE) then
    begin
      if (Att and Large<>0) and (X<ScreenLong-1) then InsMntl(Em,X,Y-1,2)
      else InsMntl(Em,X,Y-1,1);
    end;
  if (Att and Large<>0) and (X<ScreenLong-1) then InsMntl(Em,X,Y,2)
  else InsMntl(Em,X,Y,1);
end;

procedure NewCar( var Em : EmulRec; Car : char );
var Ram     : PVDispRam;
    PrecAtt : word;
    Att     : word;
    X, Y    : byte;
    Latent  : word;
begin
  Ram := Em.Ram;
  if Em.Stat.X>0 then PrecAtt := Ram^[Em.Stat.Y,Em.Stat.X-1].Att
  else PrecAtt := AttNothing;
  Att := Em.Stat.Att;
  X   := Em.Stat.X;
  Y   := Em.Stat.Y;
  Latent := Em.Stat.Latent;

  Em.Stat.LastCar := Car; { toujours avant la correction ! }
  Car := CorrigeCar(Em,Car,Att);

  PropAtt(Y,Car,Att,Latent,PrecAtt,TRUE);

  if (Em.Stat.MdIns) and (Y>0) then InsertAtt(Em,X,Y,Att);

  { on doit tenir compte des insertions en criture ! }

  WriteVDRam(Em.Ram,X,Y,Car,Att); { place en Ram }
  {$IFDEF ToScreen }
  if Em.Cfg.ToScreen then ToScreen(Em,X,Y,Car,Att); { afficher  l'ecran }
  {$ENDIF }

  CurMove(Em,X,Y,Att);

  Em.Stat.X := X;
  Em.Stat.Y := Y;
  Em.Stat.Att := (Em.Stat.Att and not(Taille)) or (Att and Taille);
  Em.Stat.Latent := Latent;
  {$IFDEF ToScreen }
  CurChange(Em);
  {$ENDIF }
end;

procedure CAN( var Em : EmulRec );
var Att     : word;
    PrecAtt : word;
    i       : word;
    Ram     : PVDispRam;
    Latent  : word;
begin
  Ram := Em.Ram;
  Att := Em.Stat.Att;
  Latent := Em.Stat.Latent;
  if Em.Stat.X>0 then PrecAtt := Ram^[Em.Stat.Y,Em.Stat.X-1].Att else PrecAtt := AttNothing;

  PropAtt(Em.Stat.Y,#32,Att,Latent,PrecAtt,FALSE); { ne peut etre delimiteur }

  for i := Em.Stat.X to ScreenLong-1 do
    begin
      DirectVDRam(Ram,i,Em.Stat.Y,#32,Att);
      if (Att and Large<>0) and (i<ScreenLong-1) then inc(i);
    end;
  {$IFDEF ToScreen }
  if Em.Cfg.ToScreen then
    begin
      if (Em.Stat.Y>1) and (Att and Haut<>0) then
        AffMntlLigne(Em,Em.Stat.Y-1,Em.Stat.X,ScreenLong-1);
      AffMntlLigne(Em,Em.Stat.Y,Em.Stat.X,ScreenLong-1);
    end;
  {$ENDIF }

  Em.Stat.Att := (Em.Stat.Att and not(Taille)) or (Att and Taille);
  Em.Stat.Latent := Latent;
end;

procedure QuitLine0( var Em : EmulRec );
begin
  if Em.Save.Use then
    begin
      Em.Stat.X      := Em.Save.X;
      Em.Stat.Y      := Em.Save.Y;
      Em.Stat.Att    := Em.Save.Att;
      Em.Stat.Latent := Em.Save.Latent;
      Em.Save.Use    := FALSE;
    end
  else
    begin { y a une erreur quelquepart ... }
      Em.Stat.X      := 0;
      Em.Stat.Y      := 1;
      Em.Stat.Att    := AttInit;
      Em.Stat.Latent := 0;
    end;
  {$IFDEF ToScreen }
  Ecrit_C(Em);
  {$ENDIF }
end;

procedure Repetition( var Em : EmulRec; How : byte );
var Ram     : PVDispRam;
    PrecAtt : word;
    Att     : word;
    X, Y    : byte;
    Latent  : word;
    Car     : char;
begin
  if Em.Stat.LastCar<>#0 then
    begin
      Ram := Em.Ram;
      X   := Em.Stat.X;
      Y   := Em.Stat.Y;
      Latent := Em.Stat.Latent;

      Att := Em.Stat.Att;

      Car := CorrigeCar(Em,Em.Stat.LastCar,Att);

      while How>0 do
        begin
          if X>0 then PrecAtt := Ram^[Y,X-1].Att
          else PrecAtt := AttNothing;
          PropAtt(Y,Car,Att,Latent,PrecAtt,FALSE);

          if (Em.Stat.MdIns) and (Y>0) then InsertAtt(Em,X,Y,Att);
          { on doit tenir compte des insertions en criture ! }

          if How>1 then DirectVDRam(Ram,X,Y,Car,Att) { <- on va + vite }
          else WriteVDRam(Ram,X,Y,Car,Att); { dernire ecriture }

          {$IFDEF ToScreen }
          if Em.Cfg.ToScreen then ToScreen(Em,X,Y,Car,Att);
          {$ENDIF }

          CurMove(Em,X,Y,Att);

          dec(How);
        end;

      Em.Stat.X := X;
      Em.Stat.Y := Y;

      Em.Stat.Att := (Em.Stat.Att and not(Taille)) or (Att and Taille);
      Em.Stat.Latent := Latent;
      {$IFDEF ToScreen }
      CurChange(Em);
      {$ENDIF }
    end;
end;

procedure Emul( var Em : EmulRec; Car : char );
begin
  Car := char(byte(Car) and 127);
  if (Car=#0) then exit;
  case Em.Aig of
    NUL :
      if Car>=#32 then NewCar(Em,Car)
      else
        case Car of
          #08 : { curseur vers la gauche }
             begin
               if Em.Stat.X=0 then
                 begin
                   if Em.Stat.Y>0 then
                     begin
                       Em.Stat.X := ScreenLong-1;
                       dec(Em.Stat.Y);
                       if Em.Stat.Y=0 then
                         if Em.Stat.MdPage then Em.Stat.Y := ScreenHigh-1
                         else
                           begin
                             Em.Stat.Y := 1;
                             ScrDown(Em,1);
                           end;
                     end;
                     { sinon, en ligne 0, on ne bouge pas ! }
                 end
               else dec(Em.Stat.X);
               {$IFDEF ToScreen }
               CurChange(Em);
               {$ENDIF }
             end;
          #09 : { curseur vers la droite }
             begin
               inc(Em.Stat.X);
               if Em.Stat.X>=ScreenLong then
                 begin
                   if Em.Stat.Y>0 then
                     begin
                       Em.Stat.X := 0;
                       inc(Em.Stat.Y);
                       if Em.Stat.Y>=ScreenHigh then
                         if Em.Stat.MdPage then Em.Stat.Y := 1
                         else
                           begin
                             Em.Stat.Y := ScreenHigh-1;
                             ScrUp(Em,1);
                           end;
                     end
                   else Em.Stat.X := ScreenLong-1;
                     { pas de dbordement en ligne 0 }
                 end;
               {$IFDEF ToScreen }
               CurChange(Em);
               {$ENDIF }
             end;
          #10 : { curseur vers le bas }
             begin
               if Em.Stat.Y>0 then
                 begin
                   inc(Em.Stat.Y);
                   if Em.Stat.Y>=ScreenHigh then
                     if Em.Stat.MdPage then Em.Stat.Y := 1
                     else
                       begin
                         Em.Stat.Y := ScreenHigh-1;
                         ScrUp(Em,1);
                       end;
                 end
               else { on quitte la ligne 0 }
                 QuitLine0(Em);
               {$IFDEF ToScreen }
               CurChange(Em);
               {$ENDIF }
             end;
          #11 : { curseur vers le haut }
             if Em.Stat.Y>0 then
               begin
                 dec(Em.Stat.Y);
                 if Em.Stat.Y=0 then
                   if Em.Stat.MdPage then Em.Stat.Y := ScreenHigh-1
                   else
                     begin
                       Em.Stat.Y := 1;
                       ScrDown(Em,1);
                     end;
                 {$IFDEF ToScreen }
                 CurChange(Em);
                 {$ENDIF }
               end;
             { ignore en ligne 0 }
          #12 : { efface ecran }
               begin
                 ClrScrMntl(Em,1,ScreenHigh-1);
                 CurHome(Em);
               end;
          #13 : { retour chariot }
               begin
                 Em.Stat.X := 0;
                 {$IFDEF ToScreen }
                 CurChange(Em);
                 {$ENDIF }
               end;
          #14 : { mode graphik }
               begin
                 Em.Stat.Att    := (Em.Stat.Att and not(Disjoint+Inverse+Taille))
                                   or Graphik;
                 Em.Stat.Latent := Em.Stat.Latent and not(Disjoint);
               end;
          #15 : { mode texte }
               begin
                 if Em.Cfg.C15Clr then
                   begin
                     Em.Stat.Latent := Em.Stat.Latent and not(Souligne);
                   end
                 else
                   begin
                     if Em.Stat.Att and Graphik<>0 then
                       Em.Stat.Latent := Em.Stat.Latent and not(Souligne);
                       { passage graphik->texte, le soulignement latent }
                       { est supprim }
                   end;
                 Em.Stat.Att := Em.Stat.Att and
                                not(Souligne+Inverse+Taille+Graphik);
               end;
          #17 : Em.Stat.CurOn := TRUE;
          #18 : Em.Aig := REP; { repetition }
          #19 : Em.Aig := SEP; { Sep (fonction) }
          #20 : Em.Stat.CurOn := FALSE;
          #24 : CAN(Em); { propage des espaces jusqu'a la fin de ligne, sans }
                         { deplacement curseur. Ce n'est pas un dlimiteur!  }
          #22,#25 : { extension alpha }
               { ce code est ignore en mode graphik !! }
               if Em.Stat.Att and Graphik=0 then Em.Aig := SS2;
          #26 : { symbole d'erreur de reception }
                NewCar(Em,char(CarErrorM1B));
          #27 : Em.Aig := ESC; { ohlala! }
          #29 : Em.Aig := SS3; { SS3,X }
          #30 : CurHome(Em); { curseur de retour en position initiale }
          #31 : begin { positionnement du curseur }
                  Em.Aig      := US;
                  Em.Pro.Par3 := 0;
                end;
        end; { case of }
  REP :
      begin { repetion }
        if Car>=#64 then Repetition(Em,byte(Car)-64);
        Em.Aig := NUL;
      end;
  SEP :
      begin { sep }
        if Car=#94 then
          begin { reset }
            Em.Stat.MdIns  := FALSE;
            Em.Stat.Att    := AttInit;
            Em.Stat.Latent := 0;
          end;
        Em.Aig := NUL;
      end;
  SS2 : { code alpha etendu }
      if Car in [#65,#66,#67,#72,#75] then
        begin
          Em.Pro.Par1 := byte(Car); { sauvegarde }
          Em.Aig      := SS2_M;
        end
      else
        begin
          if not(Car in [#68..#71,#74,#77..#79]) then
             NewCar(Em,TabExt[byte(Car)]);
          { en effet, certain code filtre au lieu d'emettre un 'Inconnu' }
          Em.Aig := NUL;
        end;
  SS2_M : { code avec accent ! }
          { "Car" contient le caractere et Par1 le type d'accent }
      begin
        NewCar(Em,TraducteurTwo(char(Em.Pro.Par1),Car));
        Em.Aig := NUL;
      end;
  SS3 : Em.Aig := NUL; { SS3, X  ignore ... }
  US : begin { positionnement curseur }
        if Em.Pro.Par3=0 then
          begin
            Em.Pro.Par1 := byte(Car); { garde }
            Em.Pro.Par3 := 1;         { pour la deuxieme coord }
          end
        else
          begin { on a les coords }
            Em.Pro.Par2 := byte(Car);
                { Par1:ligne  Par2:colonne }
            if (Em.Pro.Par1>=48) and (Em.Pro.Par1<=50) and
               (Em.Pro.Par2>=48) and (Em.Pro.Par2<=57) then
              begin { traduction car fonction CEPT }
                Em.Pro.Par1 := 64+(Em.Pro.Par1-48)*10+(Em.Pro.Par2-48);
                Em.Pro.Par2 := 65;
              end;
            if (Em.Pro.Par1>=64) and (Em.Pro.Par1<=88) and
               (Em.Pro.Par2>=65) and (Em.Pro.Par2<=104) then
              begin { coord bonne }
                if Em.Pro.Par1=64 then
                  begin { ligne Zero!! }
                    if Em.Stat.Y>0 then
                      begin { on va en ligne 0 ... }
                            { on sauve l'etat courant }
                        Em.Save.Use    := TRUE;
                        Em.Save.X      := Em.Stat.X;
                        Em.Save.Y      := Em.Stat.Y;
                        Em.Save.Att    := Em.Stat.Att;
                        Em.Save.Latent := Em.Stat.Latent;
                      end;
                  end
                else
                  begin { on va pas en ligne 0 }
                    if Em.Stat.Y=0 then { revient de la ligne zero }
                      begin
                        Em.Save.Use   := FALSE;
                        {$IFDEF ToScreen }
                        Ecrit_C(Em);
                        {$ENDIF }
                      end;
                  end;
                Em.Stat.Y := Em.Pro.Par1-64;
                Em.Stat.X := Em.Pro.Par2-65;
                { changement de l'att curseur ! }
                Em.Stat.Att    := AttInit;
                Em.Stat.Latent := 0;
                {$IFDEF ToScreen }
                CurChange(Em);
                {$ENDIF }
              end; { coord bonne }
            Em.Aig := NUL;
          end;
      end;
  ESC :
      begin { ESC X [,Y...] }
        case Car of
          #32..#47 : begin { ISO 2022 }
                       Em.Aig := ISO_2022;
                       Em.Pro.Par1 := 0;
                       Em.Pro.Par2 := byte(Car); { on garde cette information }
                     end;
          #53..#55 : Em.Aig := FILT;
          #57..#59 : begin
                       case Car of
                         #57 : Em.Aig := PRO1;
                         #58 : Em.Aig := PRO2;
                         #59 : Em.Aig := PRO3;
                       end;
                       Em.Pro.Par3 := 0;
                     end;
          #64..#71 : { trait }
                   Em.Stat.Att := (Em.Stat.Att and not(Trait))
                                  or CoulPC[byte(Car)-64];
          #72,#73 : { stabilite }
                  Em.Stat.Att := (Em.Stat.Att and not(Stable))
                                 or ((byte(Car)-72) shl 9);
          #76..#79 : { taille }
                   if Em.Stat.Att and Graphik=0 then { texte }
                     Em.Stat.Att := (Em.Stat.Att and not(Taille))
                                    or ((byte(Car)-76) shl 6);
          #80..#87 : { couleur fond }
                     { on indic fond latent }
                   begin
                     Em.Stat.Att := (Em.Stat.Att and not(Fond))
                                    or (CoulPC[byte(Car)-80] shl 3);
                     Em.Stat.Latent := Em.Stat.Latent or Fond;
                   end;
          #88 : { masquage }
                { on indique masquage latent }
               begin
                 Em.Stat.Att := (Em.Stat.Att and not(Mask)) or Mask;
                 Em.Stat.Latent := Em.Stat.Latent or Mask;
               end;
          #89,#90 : { soulignement/disjointement }
                begin
                  Em.Stat.Att := (Em.Stat.Att and not(Souligne)) or
                                 ((byte(Car)-89) shl 10);
                  Em.Stat.Latent := Em.Stat.Latent or Souligne;
                end;
          #91 : begin { CSI }
                  Em.Aig      := ISO_6429; { echappement ISO 6429 }
                  Em.Pro.Par1 := 0;
                  Em.Pro.Par2 := 0;
                  Em.Pro.Par3 := 0;
                end;
          #92,#93 : { inverse }
                  if Em.Stat.Att and Graphik=0 then { texte }
                    Em.Stat.Att := ((Em.Stat.Att and not(Inverse))
                                   or ((byte(Car)-92) shl 8));
          #95 : { demasquage }
                { on indique demasquage latent }
                begin
                  Em.Stat.Att := Em.Stat.Att and not(Mask);
                  Em.Stat.Latent := Em.Stat.Latent or Mask;
                end;
        end;
        if Em.Aig=ESC then Em.Aig:=NUL;
        { on en deduit qu'il n'y a pas de suite a donner }
      end;
  FILT : Em.Aig:=NUL; { filtrage }
  PRO1 : begin { PRO1 }
         { l'analyse porte sur Data }
           Em.Aig := NUL;
         end;
  PRO2 : begin { PRO2 }
         if Em.Pro.Par3=0 then
           begin
             Em.Pro.Par1 := byte(Car);
             Em.Pro.Par3 := 1;
           end
         else
           begin
             Em.Pro.Par2 := byte(Car);
             { l'analyse porte sur Param1 et Param2 }
             case Em.Pro.Par1 of
               $69 : { START }
                     if Em.Pro.Par2=67 then Em.Stat.MdPage := FALSE; { mode rouleau }
               $6A : { STOP }
                     if Em.Pro.Par2=67 then Em.Stat.MdPage := TRUE; { mode page }
               $66 : { TRANSPARENCE }
                     if (Em.Pro.Par2>0) and Em.Cfg.EmulTrans then
                       Em.Aig := TRANS_MODE;
             end;
             { ... }
             if Em.Aig=PRO2 then Em.Aig := NUL;
           end;
       end;
  PRO3 : begin { PRO3 }
         if Em.Pro.Par3>=2 then
           begin
             Em.Pro.Par3 := byte(Car);
             { l'analyse porte sur Par1, Par2 et Par3       }
             { simul gere un ecran minitel virtuel, et donc }
             { ne gere pas le minitel entier!!              }
             { ... }
             Em.Aig := NUL;
           end
         else
           begin
             if Em.Pro.Par3=0 then Em.Pro.Par1 := byte(Car) { si=0 }
             else Em.Pro.Par2 := byte(Car); { si=1 }
             inc(Em.Pro.Par3); { attend le parametre suivant }
           end;
       end;
  ISO_6429 :
       begin { ISO 6429 :  CSI, 3/x...3/z, 2/x...2/z,(64..127) }
         { Par1 = Parametre en cours d'estimation (0..64) }
         { Par2 = Numero Parametre (0..LongPCode-1) }
         { Par3 = etat analyse 0:ok  Autres:2/x...2/z detecte! }
         { Attention : 2/x...2/z annule l'action }
         if (Car>=#48) and (Car<=#57) then
           begin
             if Em.Pro.Par1<25 then Em.Pro.Par1 := Em.Pro.Par1*10+(byte(Car)-48)
             else Em.Pro.Par1 := 250; { signifie le debordement }
           end
         else
           if Car=#59 then
             begin { separateur de parametre detecte }
               Em.Pro.PCode[Em.Pro.Par2] := Em.Pro.Par1;
               Em.Pro.Par1 := 0;
               if Em.Pro.Par2<LongPCode-1 then inc(Em.Pro.Par2);
             end
           else
             if Car>=#64 then
               begin { le top-final de la commande est arrive }
                 if Em.Pro.Par3=0 then { pas de syntaxe error }
                   begin
                     if Em.Stat.Y>0 then
                       begin { on est pas en ligne 0 ! }
                         Em.Pro.PCode[Em.Pro.Par2] := Em.Pro.Par1;
    { PCode[0..Param2] = parametres }
    { il y a obligatoirement 1 parametre ('0' minimun) }
  case Car of
    'A'..'D' : begin { curseur move }
                 Em.Pro.Par1 := Em.Pro.PCode[0];
                   { le 1' param compte }
                 if Em.Pro.Par1=0 then Em.Pro.Par1 := 1;
                   { Param1 = nbre de decalage curseur }
                 case Car of
                   'A' : if Em.Pro.Par1>=Em.Stat.Y then Em.Stat.Y := 1
                         else dec(Em.Stat.Y,Em.Pro.Par1);
                   'B' : begin
                           inc(Em.Stat.Y,Em.Pro.Par1);
                           if Em.Stat.Y>=ScreenHigh then
                             Em.Stat.Y := ScreenHigh-1;
                         end;
                   'C' : begin
                           inc(Em.Stat.X,Em.Pro.Par1);
                           if Em.Stat.X>=ScreenLong then
                             Em.Stat.X := ScreenLong-1;
                         end;
                   'D' : if Em.Pro.Par1>=Em.Stat.X then Em.Stat.X := 0
                         else dec(Em.Stat.X,Em.Pro.Par1);
                 end;
                 {$IFDEF ToScreen }
                 CurChange(Em);
                 {$ENDIF }
               end;

     'J' : begin { effacement niveau ecran }
             Em.Pro.Par1 := Em.Pro.PCode[0]; { le 1' param interesse }
             { Param1 = type d'effacement }
             case Em.Pro.Par1 of
               0 : begin { clr du cur inclus a la fin de l'ecran }
                     ClrLigneMntl(Em,Em.Stat.Y,Em.Stat.X,ScreenLong-1);
                     ClrScrMntl(Em,Em.Stat.Y+1,ScreenHigh-1);
                   end;
               1 : begin { clr du debut ecran a cur inclus }
                     ClrScrMntl(Em,1,Em.Stat.Y-1);
                     ClrLigneMntl(Em,Em.Stat.Y,0,Em.Stat.X);
                   end;
               2 : begin { clr de tout l'ecran , cur inchange }
                     ClrScrMntl(Em,1,ScreenHigh-1);
                   end;
             end;
             {$IFDEF ToScreen }
             ScrChange;
             {$ENDIF }
           end;

     'K' : begin { effacement au niveau d'une ligne }
             Em.Pro.Par1 := Em.Pro.PCode[0]; { le premier code compte }
             { Param1 = type de clr }
             case Em.Pro.Par1 of
               0 : begin { clr du cur inclus a la fin de ligne }
                     ClrLigneMntl(Em,Em.Stat.Y,Em.Stat.X,ScreenLong-1);
                   end;
               1 : begin { clr du debut de ligne au cur inclus }
                     ClrLigneMntl(Em,Em.Stat.Y,0,Em.Stat.X);
                   end;
               2 : begin { clr la ligne , cur inchange }
                     ClrLigneMntl(Em,Em.Stat.Y,0,ScreenLong-1);
                   end;
             end;
             {$IFDEF ToScreen }
             ScrChange;
             {$ENDIF }
           end;

     'L' : begin { Insertion de lignes }
             Em.Pro.Par1 := Em.Pro.PCode[0];
             { Param1 = nbre d'insertion }
             if Em.Pro.Par1 = 0 then Em.Pro.Par1 := 1;
             while Em.Pro.Par1>0 do
               begin
                 ScrDown(Em,Em.Stat.Y);
                 dec(Em.Pro.Par1);
               end;
             Em.Stat.X := 0;
             {$IFDEF ToScreen }
             CurChange(Em);
             {$ENDIF }
           end;

     'M' : begin { suppression de lignes }
             Em.Pro.Par1 := Em.Pro.PCode[0];
             { Param1 = nbre de suppression }
             if Em.Pro.Par1=0 then Em.Pro.Par1 := 1;
             while Em.Pro.Par1>0 do
               begin
                 ScrUp(Em,Em.Stat.Y);
                 dec(Em.Pro.Par1);
               end;
             Em.Stat.X := 0;
             {$IFDEF ToScreen }
             CurChange(Em);
             {$ENDIF }
           end;

     'P' : begin { suppression de caracteres a partir du cur inclus }
             Em.Pro.Par1 := Em.Pro.PCode[0];
             { Param1 = nbre de suppression }
             if Em.Pro.Par1=0 then Em.Pro.Par1 := 1;
             SupMntl(Em,Em.Stat.X,Em.Stat.Y,Em.Pro.Par1);
           end;

     '@' : if Em.Cfg.RTIC then
             begin { insertion de caracteres a partir du cur inclus }
               Em.Pro.Par1 := Em.Pro.PCode[0];
               { Param1 = nbre d'insertion }
               if Em.Pro.Par1=0 then Em.Pro.Par1 := 1;
               InsMntl(Em,Em.Stat.X,Em.Stat.Y,Em.Pro.Par1);
             end;

     'h' : if Em.Pro.PCode[0]=4 then Em.Stat.MdIns := TRUE;
             { passage en mode insertion }
     'l' : if Em.Pro.PCode[0]=4 then Em.Stat.MdIns := FALSE;
             { passage en mode non-insertion }

     'H' : begin { adressage direct curseur }

             if Em.Pro.Par2=0 then Em.Pro.PCode[1] := 0;
               { second parametre non-initialise }
             Em.Stat.X := byte(Em.Pro.PCode[1]);
             Em.Stat.Y := byte(Em.Pro.PCode[0]);
             if Em.Stat.X>0 then Dec(Em.Stat.X);
             if Em.Stat.Y>1 then Dec(Em.Stat.Y)
             else Em.Stat.Y := 1;
             if Em.Stat.X>ScreenLong-1 then Em.Stat.X := ScreenLong-1;
             if Em.Stat.Y>ScreenHigh-1 then Em.Stat.Y := ScreenHigh-1;
             {$IFDEF ToScreen }
             CurChange(Em);
             {$ENDIF }
           end;
  end; { case of }
                    Em.Aig := NUL;
                       end { Y>1 }
                     else Em.Aig := NUL; { ignore CSI en ligne 0 }
                   end
               else Em.Pro.Par3 := 1; { indic analyse anormale }
           end; { top of param }
       end; { ISO 6429 }
  ISO_2022 : begin { ISO 2022 : 27, 2/x...2/z, (48..127) }
         { param2 = premier code apres 27 (ESC) }
         Em.Pro.PCode[Em.Pro.Par1] := byte(Car);
         if (Car>=#48) or (Em.Pro.Par1>=LongPCode-1) then
           begin { le top-final est la }
             Em.Aig := NUL;
           end
         else inc(Em.Pro.Par1);
       end; { ISO 2022 }
  TRANS_MODE : begin { emule le mode transparence... }
         dec(Em.Pro.Par2);
         if Em.Pro.Par2=0 then Em.Aig := NUL;
       end;
      end; { case of }
end;

end.
