{$A+,B-,E-,F-,N-,O-,V-,I- }

{$IFDEF DEBUG }
  {$D+,L+,R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit RamDisk;

interface

procedure ResetGetRam;
procedure OpenRam;
procedure CloseRam;
procedure PutRam( data : byte );
procedure MoveRam( var p; long : word );
procedure WriteRam( txt : string );
function  LongRam : word;
function  GetRam : byte;
procedure ReadRam( var p; lg : word; var result : word );

implementation

type PBufRec = ^BufRec;
     BufRec = record
         Lg   : word;
         Don  : array[1..256] of byte;
         next : PBufRec;
       end;

var First  : PBufRec;
    Last   : PBufRec;
    CrrBuf : PBufRec;
    lev    : word;

procedure ResetGetRam;
begin
  CrrBuf := First;
  lev    := 0;
end;

procedure OpenRam;
begin
  new(First);        { cr le premier buffer }
  Last        := First;
  First^.lg   := 0;
  First^.next := nil;
  ResetGetRam;
end;

procedure CloseRam;
var n : PBufRec;
begin
  while First<>nil do
    begin
      n := First^.next;
      dispose(First);
      First := n;
    end;
end;

procedure PutRam( data : byte );
var b : PBufRec;
begin
  inc(Last^.lg);
  Last^.Don[Last^.lg] := data;
  if Last^.lg>=sizeof(Last^.Don) then
    begin
      new(b);
      Last^.next := b;
      Last := b;
      b^.lg := 0;
      b^.next := nil;
    end;
end;

procedure MoveRam( var p; long : word );
var don  : array[1..32767] of byte absolute p;
    t, i : word;
    b : PBufRec;
begin
  i := 1;
  while long>0 do
    begin
      if long>=sizeof(Last^.Don)-Last^.lg then
        t := sizeof(Last^.Don)-Last^.lg
      else t := long;
      move(don[i],Last^.Don[Last^.lg+1],t);
      inc(i,t);
      dec(long,t);
      inc(Last^.lg,t);
      if Last^.lg>=sizeof(Last^.Don) then
        begin
          new(b);
          Last^.next := b;
          Last := b;
          b^.lg := 0;
          b^.next := nil;
        end;
    end;
end;

procedure WriteRam( txt : string );
begin
  MoveRam(txt[1],length(txt));
end;

function LongRam : word;
var b : PBufRec;
    how : word;
begin
  b := First;
  how := 0;
  while b<>nil do
    begin
      inc(how,b^.lg);
      b := b^.next;
    end;
  LongRam := how;
end;

function GetRam : byte;
begin
  if CrrBuf=nil then GetRam := 0
  else
    begin
      inc(lev);
      GetRam := CrrBuf^.Don[lev];
      if lev>=CrrBuf^.lg then
        begin
          CrrBuf := CrrBuf^.next;
          lev    := 0;
        end;
    end;
end;

procedure ReadRam( var p; lg : word; var result : word );
var dest : array[1..32767] of byte absolute p;
    t    : word;
    how  : word;
begin
  how := 0;
  while (lg>0) and (CrrBuf<>nil) do
    begin
      if lg>=CrrBuf^.lg-lev then t := CrrBuf^.lg-lev
      else t := lg;
      move(CrrBuf^.Don[lev+1],dest[how+1],t);
      inc(how,t);
      dec(lg,t);
      inc(lev,t);
      if lev>=CrrBuf^.lg then
        begin
          CrrBuf := CrrBuf^.next;
          lev    := 0;
        end;
    end;
  result := how;
end;

end.
