{$A+,B-,E-,F-,N-,O-,V-,I- }

{$IFDEF DEBUG }
  {$D+,L+,R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit VdtDisp;

interface

(*
uses VdtTools;
*)

const ScreenLong = 40;
      ScreenHigh = 25;  { la ligne 0 est speciale }

      OM_Nothing = 0;   { different etat de OptMem }
      OM_Some    = 1;
      OM_All     = 2;
type
     VDispCfg = record
         CSI          : boolean;  { Optimise deplacement avec CSI }
         OptInvGrp    : boolean;  { Optimise si effet invisible }
         OptInvTxt    : boolean;  { Optimise si effet invisible }
         OptRepet     : boolean;  { Optimise si repetition }
         xRep         : boolean;  { fait toujours prcder le car  repeter }
         ComplAsSpace : boolean;  { Les complements sont des espaces }
         ForceDelGrp  : boolean;  { Force ecriture du delimiteur graphik }
         ForceDelTxt  : boolean;  { Force ecriture du delimiteur texte }
         VideAsSpace  : boolean;  { saute les places vides }
         OptWithCan   : boolean;  { Si l'on peut optimiser avec le code CAN }
         OptSpclGrp   : boolean;  { formule non orthodoxe pour optimiser }
         OptSpclTxt   : boolean;  { idem pour le mode texte }
         C15Clr       : boolean;  { #15 annule le soulignement latent }
         OptMem       : byte;     { optimise si dj en Ram }
         DebCursor    : Boolean;  { debordement du curseur autoris? }
         Scroll       : Boolean;  { cran en mode Rouleau ? }
       end;

     VDispCur = record  { etat courant du curseur }
         X, Y  : byte;
         Att   : word;
         Rdy   : Boolean;  { FALSE => curseur non dfini }
       end;

     VDispWaiting = record
         X,Y    : byte;         { position o ecrire le car en attente }
         Car    : char;         { caractre en attente }
         Nb     : word;         { nombre d'attente }
         CurAtt : word;         { Etat du CURSEUR aprs changement d'attribut }
                                { et avant ecriture du caractre  }
                                { (quoi que l'etat reste le mme) }
       end;

     VDispRamEl = record
         Car  : char;
         Att  : word;
       end;
     PVDispRamEl = ^VDispRamEl;

     VDispRamLine = array[0..ScreenLong-1] of VDispRamEl;
     PVDispRamLine = ^VDispRamLine;

     VDispRam = array[0..ScreenHigh-1] of VDispRamLine;
     PVDispRam = ^VDispRam;

     VDispRec = record
         Cfg     : VDispCfg;      { configuration }
         LastCar : Char;          { dernier caractre emis }
         SpcDel  : boolean;       { car precedent est un space delimiteur }
         Cur     : VDispCur;      { position virtuel du curseur }
         Wait    : VDispWaiting;  { etat en attente ... }
         Ram     : PVDispRam;     { mmoire video ... 3 Ko }
         NextLn  : Boolean;       { TRUE=>curseur passer  la ligne suivante }
       end;


procedure InRam( Ram : PVDispRam;
                 X,Y : byte;
                 Car : char;
                 Att : word );

procedure WriteVDRam( Ram : PVDispRam;
                      X,Y : byte;
                      Car : char;
                      Att : word );

procedure DirectVDRam( Ram : PVDispRam;
                       X,Y : byte;
                       Car : char;
                       Att : word );

procedure DelimRamLine( RamLine : VDispRamLine );
procedure DelimRam( Ram : PVDispRam );

procedure FlushTrans( var VD : VDispRec; var s  : string );

procedure TransCode( var VD     : VDispRec;
                     X,Y        : byte;
                     Car        : char;
                     Att        : word;
                     var result : string );

procedure TransCodeScrollDown( var VD     : VDispRec;
                               var result : string );

procedure TransCodeScrollUp( var VD     : VDispRec;
                             var result : string );

procedure ClearRam( Ram : PVDispRam );

procedure SetDefaultVD( var Cfg : VDispCfg );

procedure InitVD( var VD : VDispRec );


implementation

const DefaultCfg : VDispCfg = (
          CSI          : TRUE;    { Optimise deplacement avec CSI }
          OptInvGrp    : FALSE;   { Optimise si invisible }
          OptInvTxt    : FALSE;   { Optimise si invisible }
          OptRepet     : TRUE;    { Optimise si repetition }
          xRep         : FALSE;   { fait toujours prcder le car  repeter }
          ComplAsSpace : FALSE;   { Les complements sont des espaces }
          ForceDelGrp  : FALSE;   { Force ecriture du delimiteur graphik }
          ForceDelTxt  : FALSE;   { Force ecriture du delimiteur texte }
          VideAsSpace  : FALSE;   { ignore les places vides }
          OptWithCan   : TRUE;    { optimise avec le code CAN }
          OptSpclGrp   : FALSE;   { optimisation special avec code #14 }
          OptSpclTxt   : FALSE;   { op avec le code #15 }
          C15Clr       : FALSE;   { #15 n'annule pas le soulignement latent }
          OptMem       : OM_Nothing;
          DebCursor    : FALSE;
          Scroll       : FALSE
        );

type
     CMoveRec = record
         CLeft  : ShortInt;  { #8 }
         CRight : ShortInt;  { #9 }
         CDown  : ShortInt;  { #10 }
         CUp    : ShortInt;  { #11 }
         How    : word;      { nombre total de codes de dplacements }
       end;

     CResultRec = record
         X,Y     : byte;
         Car     : char;
         Att     : word;     { etat attribut aprs analyse }

         Mode    : byte;     { mode de dplacement }
         Move    : CMoveRec; { detail du deplacement relatif }

         CAtt    : word;     { attributs changeant }
         NbCA    : word;     { nombre de codes pour chang l'attribut }
                             { relatif au mode de dplacement }

         Total   : word;     { nombre de code total : }
                             { positionnement curseur+attributs a changer }

         CurAtt  : word;     { etat de l'attribut curseur (aprs tous) }

       end;

const Trait      = 7;
      Fond       = 56;
      Taille     = 192;
      Inverse    = 256;
      Stable     = 512;
      Disjoint   = 1024;
      Souligne   = 1024;
      Mask       = 2048;

      Graphik    = 8192;

      Delim      = 32768;

      Complement = 176;
      Haut       = 64;
      Large      = 128;

      AttNothing = Trait+Stable+Graphik;


procedure InRam( Ram : PVDispRam;
                 X,Y : byte;
                 Car : char;
                 Att : word );
var exAtt : word;
    El    : PVDispRamEl;
    EndB  : boolean;
begin
  El := @Ram^[Y,X];
  El^.Car := Car;    { ecrit Car }
  El^.Att := Att;    { ecrit Att }
  inc(X);
  if X<=ScreenLong-1 then
    begin
      exAtt := Ram^[Y,X].Att;
      if ((exAtt and Graphik<>0) and (exAtt and Mask<>Att and Mask)) or
         ((exAtt and Graphik=0) and (exAtt and
           (Fond+Souligne+Mask)<>Att and (Fond+Souligne+Mask))) then
        begin { c'est different, donc a modifier }
          EndB := FALSE;
          repeat
            El := @Ram^[Y,X];
            exAtt := El^.Att;
            if exAtt and Delim<>0 then EndB := TRUE
            else
              begin
                if exAtt and Graphik<>0 then
                  begin { car graphik }
                    Att := (Att and not(Fond+Souligne)) or
                           (exAtt and (Fond+Souligne));
                      { chope les attributs Fond et soul au passage }
                    exAtt := (exAtt and not(Mask)) or
                             (Att and Mask);   { ne donne que le mask }
                  end
                else
                  begin { car texte }
                    exAtt := (exAtt and not(Fond+Souligne+Mask)) or
                             (Att and (Fond+Souligne+Mask));
                  end;
                El^.Att := exAtt;
                inc(X);
              end;
          until (X>=ScreenLong) or EndB;
        end;
    end;
    { sinon, inutile de faire quoi que ce soit d'autre ... }
end;

procedure WriteVDRam( Ram : PVDispRam;
                      X,Y : byte;
                      Car : char;
                      Att : word );
{ ici, on ne procupe que des influences vers l'avant  }
{ on considre que Att est conforme dans tous les cas. }
{ on ne corrige que les influences sur les caractres  }
{  droite ...                                         }
{ il y a gain de temps si on commence par ecrire les   }
{ complements  droites ...                            }
begin
  if (Att and Haut<>0) and (Y>1) then
    begin
      if (Att and Large<>0) and (X<ScreenLong-1) then
        InRam(Ram,X+1,Y-1,char(Complement),Att);
      InRam(Ram,X,Y-1,char(Complement),Att);
    end;
  if (Att and Large<>0) and (X<ScreenLong-1) then
    InRam(Ram,X+1,Y,char(Complement),Att);
  InRam(Ram,X,Y,Car,Att);
end;

procedure DirectVDRam( Ram : PVDispRam;
                       X,Y : byte;
                       Car : char;
                       Att : word );
{ place directement en Ram (sans modifier les delimitations }
begin
  Ram^[Y,X].Car := Car;
  Ram^[Y,X].Att := Att;
  if (Att and Haut<>0) and (Y>1) then
    begin
      Ram^[Y-1,X].Car := char(Complement);
      Ram^[Y-1,X].Att := Att;
      if (Att and Large<>0) and (X<ScreenLong-1) then
        begin
          Ram^[Y-1,X+1].Car := char(Complement);
          Ram^[Y-1,X+1].Att := Att;
        end;
    end;
  if (Att and Large<>0) and (X<ScreenLong-1) then
    begin
      Ram^[Y,X+1].Car := char(Complement);
      Ram^[Y,X+1].Att := Att;
    end;
end;

procedure DelimRamLine( RamLine : VDispRamLine );
{ corrige les attributs dlimiteurs et declare les dlimiteurs... etc ... }
var PrecAtt : word;
    Att     : word;
    Car     : char;
    X       : word;
begin
  PrecAtt := AttNothing;
  for X := 0 to ScreenLong-1 do
    begin
      Car := RamLine[X].Car;
      Att := RamLine[X].Att;
      if Car<>#0 then
        if Att and Graphik=0 then
          begin { car texte }
            Att := Att and not(Delim);
            if PrecAtt and Graphik<>0 then PrecAtt := PrecAtt and not(Souligne);
            if Car=#32 then
              begin { peut tre un dlimiteur }
                if (PrecAtt and (Fond+Souligne+Mask))<>
                   (Att and (Fond+Souligne+Mask)) then
                  begin { changement d'attribut! }
                    Att := Att or Delim;
                  end;
              end
            else
              Att := (Att and not(Mask+Souligne+Fond)) or
                     (PrecAtt and (Mask+Souligne+Fond));
              { recoit les zones prcdentes ... }
          end
        else
          begin { car graphik }
            Att := Att and not(Delim+Taille+Inverse);
            if Car=#32 then
              begin { peut tre un dlimiteur }
                if (PrecAtt and Mask)<>(Att and Mask) then
                  begin { changement d'attribut! }
                    Att := Att or Delim;
                  end;
              end
            else
              Att := (Att and not(Mask)) or (PrecAtt and Mask);
              { recoit la zone Mask prcdente ... }
          end
      else Att := AttNothing or (PrecAtt and Mask);
      RamLine[X].Att := Att;
      PrecAtt := Att;
    end;
end;

procedure DelimRam( Ram : PVDispRam );
var Y : word;
begin
  for Y := 0 to ScreenHigh-1 do DelimRamLine(Ram^[Y]);
end;

procedure CChange( var Cfg : VDispCfg;  { configuration }
                   Ram     : PVDispRam; { Ram video }
                   X,Y     : byte;      { position }
                   Car     : char;      { caractre }
                   AS      : word;      { attribut souhait }
                   AttC    : word;      { etat de l'attribut courant }
                   var r   : CResultRec );
var h       : word;  { howR }
    n       : word;  { CA }
    PrecAtt : word;  { Precendent attribut (pour les delimiteurs) }
begin
  h  := 0; { nombre de codes videotex }
  n  := 0; { attributs variant }
  if X>0 then PrecAtt := Ram^[Y,X-1].Att else PrecAtt := AttNothing;
  if AttC and Graphik=0 then
    begin { l'attribut courant est dans le mode texte }
      if AS and Graphik<>0 then
        begin { texte -> graphik }
          n := n or Graphik;  { changement du bit graphik }
          inc(h);             { emission 1 code #14 }
          AttC := AttC and not(Disjoint+Inverse+Taille);
              { car le bit est invalide en mode texte ! }
              { et le code #14 annule ce bit }
              { Inverse et Taille n'existe pas en graphik }
        end
      else
        begin { texte -> texte }
          if Y<=1 then
            begin
              AS := AS and not(Haut);     { ici la double hauteur n'existe pas }
              AttC := AttC and not(Haut); { idem, forcment ... }
            end;
          if Cfg.OptSpclTxt and
             (AS and (Taille+Inverse)=0) and
             ((AttC and (Taille+Inverse))<>0) then
            if Cfg.C15Clr then
              begin
                { ici, le code 15 desactive le soulignement latent ... }
                n := n or Graphik;
                inc(h);            { code 15 }
                AttC := AttC and not(Souligne+Inverse+Taille);
              end
            else
              begin
                { Cas special: le code 15 ne desactive pas le }
                { soulignement latent... sur M1 et M1B }
                n := n or Graphik;
                inc(h);            { code 15 }
                AttC := AttC and not(Inverse+Taille);
              end;
        end;
    end
  else
    begin { attribut courant dans le mode graphik! }
      if AS and Graphik=0 then
        begin { graphik -> texte }
          n := n or Graphik;
          inc(h);             { code 15 }
          AttC := AttC and not(Disjoint+Inverse+Taille);
        end
      else
        begin { graphik -> graphik }
          if Cfg.OptSpclGrp and
             ((AttC and Disjoint)<>0) and
             ((AS and Disjoint)=0) then
            begin
              { #14 eteind le bit disjoint! }
              { c + rapide que #27 #disoff! }
              n := n or Graphik;
              inc(h);
              AttC := AttC and not(Disjoint); { #14 }
            end;
        end;
    end;

  if AS and Graphik=0 then
    begin { mode texte }
      if (AttC and Taille)<>(AS and Taille) then
        begin { changement de la taille }
          n := n or Taille;
          inc(h,2);     { 2 codes }
        end;
      if (AttC and Inverse)<>(AS and Inverse) then
        begin { changement d'etat inverse }
          n := n or Inverse;
          inc(h,2);     { 2 codes }
        end;
      AttC := (AttC and not(Taille+Inverse+Graphik)) or
              (AS and (Taille+Inverse+Graphik));
        { l'attribut du curseur reprend les changements apports }
        { Graphik est indispensable... }
        { note: les changements lis aux dlimiteurs suivent ... }

      AS := AS and not(Delim);  { pas dlimiteur par dfaut }
      if PrecAtt and Graphik<>0 then PrecAtt := PrecAtt and not(Souligne);
        { en effet, si graphik, il s'agit du bit disjoint, ce qui est }
        { sans rapport avec le bit souligne, qui doit tre vu  0 }
      if Car=#32 then
        begin { peut tre un dlimiteur ... }
          if Cfg.ForceDelTxt or
             ((PrecAtt and (Fond+Souligne+Mask))<>
              (AS and (Fond+Souligne+Mask))) then
            begin
              { l'etat des delimiteurs courants diffre de l'etat }
              { qu'on souhaite atteindre ... }
              if (AttC and Fond)<>(AS and Fond) then
                begin { on doit changer le fond }
                  n := n or Fond;
                  inc(h,2);       { 2 codes ... }
                end;
              if (AttC and Souligne)<>(AS and Souligne) then
                begin { changer le soulignement }
                  n := n or Souligne;
                  inc(h,2);       { 2 codes ... }
                end;
              if (AttC and Mask)<>(AS and Mask) then
                begin { changer le mask }
                  n := n or Mask;
                  inc(h,2);       { 2 codes ... }
                end;
              if n and (Fond+Souligne+Mask)=0 then
                begin
                  { l'etat latent est identique  l'etat }
                  { souhait! pour quand mme placer le  }
                  { delimiteur, il faut au moins emettre 2 codes ... }
                  { on remet le masque... (a aurait pu tre le fond ou soul) }
                  { mais le masque tant plus rare, ce sera plus marquant ! }
                  n := n or Mask;
                  inc(h,2);       { 2 codes }
                end;
              AS := AS or Delim;
                      { les 3 dlimiteurs sont toujours actif en mme }
                      { temps en mode texte ! }
              AttC := (AttC and not(Fond+Souligne+Mask)) or
                      (AS and (Fond+Souligne+Mask));
            end;
        end
      else
        begin { en aucun cas ce ne peut tre un dlimiteur }
              { donc on reprend les attributs precdent }
              { sans pouvoir agir contre... }
          AS := (AS and not(Mask+Souligne+Fond)) or
                (PrecAtt and (Mask+Souligne+Fond));
        end;

      { Trait,Stable si visible... }
      { a se place ici car le "AS and Souligne" renverra un }
      { resultat juste... en fonction de delimiteur ou non , }
      { etat soulign correcte ou pas ... }
                                            {  "or (AS and Delim<>0)" --------> }
      { car dans le cas d'un dlimiteur, le soulignement n'est pas visible! }
      if not( Cfg.OptInvTxt and (Car=#32) and
              ((AS and Souligne=0) or (AS and Delim<>0))
              and (AS and Inverse=0) ) then
        begin
          if (AttC and Trait)<>(AS and Trait) then
            begin { changement de la couleur du trait }
              n := n or Trait;
              inc(h,2);        { 2 codes }
            end;
          if (AttC and Stable)<>(AS and Stable) then
            begin { changement de l'etat stable }
              n := n or Stable;
              inc(h,2);        { 2 codes }
            end;
          AttC := (AttC and not(Trait+Stable)) or (AS and (Trait+Stable));
        end
      else AS := (AS and not(Trait+Stable)) or (AttC and (Trait+Stable));
    end
  else
    begin { mode graphik }
      AS := AS and not(Taille+Inverse);

      if (AttC and Fond)<>(AS and Fond) then
        begin { changement de fond }
          n := n or Fond;
          inc(h,2);       { emission de 2 codes:  #27 #fond }
        end;
      { Trait,Stable,Disjoint si visible... }
      if not(Cfg.OptInvGrp and (Car=#32)) then
        begin
          if (AttC and Trait)<>(AS and Trait) then
            begin { changement de la couleur du trait }
              n := n or Trait;
              inc(h,2);        { 2 codes }
            end;
          if (AttC and Stable)<>(AS and Stable) then
            begin { changement de l'etat stable }
              n := n or Stable;
              inc(h,2);        { 2 codes }
            end;
          if (AttC and Disjoint)<>(AS and Disjoint) then
            begin { changement d'etat Disjoint }
              n := n or Disjoint;
              inc(h,2);     { 2 codes }
            end;
          AttC := (AttC and not(Trait+Stable+Disjoint)) or
                  (AS and (Trait+Stable+Disjoint));
        end
      else AS := (AS and not(Trait+Stable+Disjoint)) or
                 (AttC and (Trait+Stable+Disjoint));
      { Note: Pour l'espace, on ne peut voir l'effet clignotant    }
      {       disjoint ou le trait                                 }
      AttC := (AttC and not(Fond+Taille+Inverse+Graphik)) or
              (AS and (Fond+Graphik));
      AS := AS and not(Delim); { par dfaut }
      if Car=#32 then
        begin { peut tre un dlimiteur de mask ... }
          if Cfg.ForceDelGrp or ((PrecAtt and Mask)<>(AS and Mask)) then
            begin
              n := n or Mask;
              inc(h,2);       { 2 codes ... }
              AS := AS or delim;  { delimiteur de mask ... }
              AttC := (AttC and not(Mask)) or (AS and Mask);
            end;
        end
      else
        begin { en aucun cas ce ne peut tre un dlimiteur Mask }
              { donc on reprend l'attribut precdent }
              { sans pouvoir agir contre... }
          AS := (AS and not(Mask)) or (PrecAtt and Mask);
        end;
    end;

  FillChar(r,sizeof(r),0);
  r.X      := X;
  r.Y      := Y;
  r.Car    := Car;
  r.Att    := AS;

  r.CAtt   := n;
  r.NbCA   := h;
  r.CurAtt := AttC;
end;

const BM_Norm       = 0;
      BM_13         = 1;
      BM_Home       = 2;
      BM_31         = 3;
      BM_CSI_DIRECT = 4;
      BM_CSI_Home   = 5;

procedure BestWay( var Cfg    : VDispCfg;
                   DepX, DepY : byte;
                   ArrX, ArrY : byte;
                   rOt        : CResultRec;
                   r3X        : CResultRec;
                   var Result : CResultRec;
                   IgnDep     : Boolean );

  procedure CMove0( DepX, ArrX : ShortInt; var R : CMoveRec );
  { mouvement en ligne 0 }
  var DistX : ShortInt;
  begin
    FillChar(R,sizeof(R),0);
    DistX := ArrX-DepX;
    if DistX<0 then
      { A <-- D }
      R.CLeft := Abs(DistX)
    else
      { D --> A }
      R.CRight := DistX;
    R.How := DistX;
  end;

  procedure CMove( DepX, DepY, ArrX, ArrY : byte;
                   Debord     : boolean;
                   var Result : CMoveRec );
  { pour les dplacements sur la ligne 0, utilis CMove0 }
  var r     : CMoveRec;
      DistX : ShortInt;
      DistY : ShortInt;
  begin
    FillChar(r,sizeof(r),0);
    DistX := ArrX-DepX;
    if DistX<0 then
      begin { A <-- D }
        if Debord and (Abs(DistX)>ScreenLong div 2) and
           ((DepY+1<ScreenHigh) or Cfg.DebCursor) then
          begin {  -->A     D-- on passe par derrire ... }
            r.CRight := ScreenLong+DistX;
            inc(DepY);
            if DepY>=ScreenHigh then DepY := 1;
          end
        else
          begin { A <-- D }
            r.CLeft := Abs(DistX);
          end;
      end
    else
      begin { D --> A }
        if Debord and (DistX>ScreenLong div 2) and
           ((DepY>1) or Cfg.DebCursor) then
          begin { --D    A<-- }
            r.CLeft := ScreenLong-DistX;
            dec(DepY);
            if DepY<1 then DepY := ScreenHigh-1;
          end
        else
          begin { D --> A }
            r.CRight := DistX;
          end;
      end;
    DistY := ArrY-DepY;
    if DistY<0 then
      begin { A<-- D }
        if Debord and (Abs(DistY)>(ScreenHigh-1) div 2) and
           Cfg.DebCursor then
          begin {  -->A  D-- on passe par derrire ... }
            r.CDown := (ScreenHigh-1)+DistY;
          end
        else
          begin { A <-- D }
            r.CUp := Abs(DistY);
          end;
      end
    else
      begin { D --> A }
        if Debord and (DistY>(ScreenHigh-1) div 2) and
           Cfg.DebCursor then
          begin { --D    A<-- }
            r.CUp := (ScreenHigh-1)-DistY;
          end
        else
          begin { D --> A }
            r.CDown := DistY;
          end;
      end;
    r.How := r.CLeft+r.CRight+r.CDown+r.CUp;
    Result := r;
  end;

  procedure ConvertToCSI( var Result : CMoveRec );
    procedure ToCSI( var c : ShortInt; var how : word );
    { 1B 5B X Z  }
    { 1B 5B XX Z }
    begin
      if c>=5 then
        begin { on remplace par CSI ! }
          dec(how,c);
          if c>=10 then inc(how,5) { version 1B 5B XX Z }
          else inc(how,4);         { version 1B 5B X Z }
          c := -c;
        end;
    end;
  var r : CMoveRec;
  begin
    r := Result;
    ToCSI(r.CLeft,r.How);
    ToCSI(r.CRight,r.How);
    ToCSI(r.CDown,r.How);
    ToCSI(r.CUp,r.How);
    Result := r;
  end;

var r    : CMoveRec;
    h    : word;
    Best : CMoveRec;
    mode : word;
    How  : word;

    Nb3X : word; { nombre de code a emettre avec 31XY ou 30 }

    NbOt : word; { nombre de code avec les autres deplacament }

begin

  NbOt := rOt.NbCA;
  Nb3X := r3X.NbCA;

  if Not(IgnDep) And (DepY=0) then
    if ArrY=0 then
      begin { dplacement en ligne 0 <--> }
            { on peut utiliser: normal }
            {                   #13 normal }
            {                   #31#0#col  }
        CMove0(DepX,ArrX,Best);
        mode := BM_Norm;
        How  := Best.How+NbOt;

        CMove0(0,ArrX,r);
        h := r.How+1+NbOt;
        if h<How then
          begin
            Best := r;
            How  := h;
            mode := BM_13;     { c'est meilleur }
          end;

        h := 3+Nb3X;
        if h<how then
          begin
            FillChar(Best,sizeof(Best),0);
            How  := h;
            mode := BM_31;    { c'est meilleur! }
          end;
      end
    else
      begin { saut de la ligne 0  une autre (1..24) }
        { ici, on n'a que l'alternative #31yx ou #30... }
        CMove(0,1,ArrX,ArrY,TRUE,Best);
        How  := Best.How+1+Nb3X;   { +1 car #30 }
        mode := BM_Home;

        h := 3+Nb3X;
        if h<how then
          begin
            FillChar(Best,sizeof(Best),0);
            How  := h;
            mode := BM_31;    { c'est meilleur avec #31YX ! }
          end;

        if Cfg.CSI and (how>1+4+Nb3X) then  { how> #30+#$1B#$5B#X'A'+Nb3X }
          begin
            { #30 puis un dplacement... }
            CMove(0,1,ArrX,ArrY,FALSE,r);
            ConvertToCSI(r);
            h := r.How+1+Nb3X; { 1=#30 }
            if h<how then
              begin { c'est mieux ! }
                Best := r;
                How  := h;
                mode := BM_Home;
              end;
          end;
      end
  else
    if ArrY=0 then
      begin { saut d'une ligne 1..24  la ligne 0 }
        { la seule mthode est #31#64#colonne ! }
        FillChar(Best,sizeof(Best),0);
        How  := 3+Nb3X;
        mode := BM_31;
      end
    else
      begin { mouvements normaux entre lignes 1..24 }
        If Not(IgnDep) Then
         Begin
          CMove(DepX,DepY,ArrX,ArrY,TRUE,Best);
          How  := Best.How+NbOt;
          mode := BM_Norm;

          CMove(0,DepY,ArrX,ArrY,TRUE,r);
          h := r.How+1+NbOt;
          if h<How then
            begin
              Best := r;
              How  := h;
              mode := BM_13;  { c'est meilleur avec #13 }
            end;
         End
        Else How := 65535;

        CMove(0,1,ArrX,ArrY,TRUE,r);
        h := r.How+1+Nb3X;
        if h<how then
          begin
            Best := r;
            How  := h;
            mode := BM_Home;  { c'est meilleur avec #30 }
          end;

        h := 3+Nb3X;
        if h<how then
          begin
            FillChar(Best,sizeof(Best),0);
            How    := h;
            mode   := BM_31;  { c'est encore mieux avec #31XY }
          end;

        if Cfg.CSI then
          begin
            if (how>3+NbOt) then
              begin { on peut tre faire mieux en CSI ... }

                { on essaye d'abord l'adressage direct! }
                h := 3+NbOt; { au minimun: 1B 5B 48 (Home) puis les codes... }
                if ArrX>0 then
                  if ArrX>=9 then inc(h,3)   { ";XX" }
                  else inc(h,2);             { ";X" }
                if ArrY>1 then
                  if ArrY>=10 then inc(h,2)  { "YY" }
                  else inc(h);               { "Y" }
                if h<how then
                  begin { un adressage direct en CSI est meilleur }
                    FillChar(Best,sizeof(Best),0);
                    How  := h;
                    mode := BM_CSI_DIRECT;
                  end;

                if how>4+NbOt then
                  begin { recherchons plus loin... }

                    If Not(IgnDep) Then
                     Begin
                      { normal ... }
                      CMove(DepX,DepY,ArrX,ArrY,FALSE,r);
                      ConvertToCSI(r);
                      h := r.How+NbOt;
                      if h<how then
                        begin { it's better ! }
                          Best := r;
                          How  := h;
                          mode := BM_Norm; { et oui! }
                        end;

                      { #13 puis un dplacement... }
                      CMove(0,DepY,ArrX,ArrY,FALSE,r);
                      ConvertToCSI(r);
                      h := r.How+1+NbOt; { 1=#13 }
                      if h<how then
                        begin { c'est mieux ! }
                          Best := r;
                          How  := h;
                          mode := BM_13;
                        end;
                     End
                    Else How := 65535;

                    { home puis un dplacement... }
                    CMove(0,1,ArrX,ArrY,FALSE,r);
                    ConvertToCSI(r);
                    h := r.How+3+NbOt; { 3=Home CSI: 1B 5B H }
                    if h<how then
                      begin { c'est mieux ! }
                        Best := r;
                        How  := h;
                        mode := BM_CSI_Home;
                      end;
                  end;
              end;
            if how>1+4+Nb3X then
              begin
                { #30 puis un dplacement... }
                CMove(0,1,ArrX,ArrY,FALSE,r);
                ConvertToCSI(r);
                h := r.How+1+Nb3X; { 1=#30 }
                if h<how then
                  begin { c'est mieux ! }
                    Best := r;
                    How  := h;
                    mode := BM_Home;
                  end;
              end;
          end;
      end;

  FillChar(Result,sizeof(Result),0);

  if (mode=BM_Home) or (mode=BM_31) then Result  := r3X
  else Result := rOt;
  Result.mode  := mode;
  Result.Move  := Best;
  Result.Total := How;
end;


Procedure ScrollDown( Var VD : VDispRec );
Begin
 If VD.Wait.Y<ScreenHigh-1 Then Inc(VD.Wait.Y);
End;


Procedure ScrollUp( Var VD : VDispRec );
Begin
 If VD.Wait.Y>1 Then Dec(VD.Wait.Y);
End;


procedure NextCol( Var VD : VDispRec; var X, Y : byte; Att : word );
begin
  if Att and Large<>0 then inc(X,2)
  else inc(X);
  if X>ScreenLong-1 then
   Begin
    VD.NextLn := TRUE;
    if Y>0 then
      begin
         X := 0;
         if Att and Haut<>0 then
           begin
             inc(Y,2);
             if Y>=ScreenHigh then
              If VD.Cfg.Scroll Then
               Begin
                ScrollUp(VD);
                ScrollUp(VD);
                Y := ScreenHigh-1;
               End
              Else Y := 2;
           end
         else
           begin
             inc(Y);
             if Y>=ScreenHigh then
              If VD.Cfg.Scroll Then
               Begin
                ScrollUp(VD);
                Y := ScreenHigh-1;
               End
              Else Y := 1;
           end;
      end
    else X := ScreenLong-1; { dbordement impossible en ligne 0 }
   End;
end;


const
      TabInf32  : array[24..27] of char = ('-','/','.',','); { les flches }

      TabSup128 : array[128..255,1..2] of char = (
{  128} (#75,'C'),(#72,'u'),(#66,'e'),(#67,'a'),(#72,'a'),(#65,'a'), {  }
{  134} (#00,#00),(#75,'c'),(#67,'e'),(#72,'e'),(#65,'e'),(#72,'i'), {  }
{  140} (#67,'i'),(#00,'i'),(#00,'A'),(#67,'A'),(#66,'E'),('z',#00), {  }
{  146} ('j',#00),(#67,'o'),(#72,'o'),(#00,'o'),(#67,'u'),(#65,'u'), {  }
{  152} (#00,'y'),(#00,'O'),(#00,'U'),(#00,#00),('#',#00),(#00,#00), {  }
{  158} (#00,#00),(#00,#00),(#00,'a'),(#00,'i'),(#00,'o'),(#00,'u'), {  }
{  164} (#00,'n'),(#00,'N'),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  170} (#00,#00),('=',#00),('<',#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  176} (#0,#127),(#0,#127),(#0,#127),(#00,'|'),(#00,#00),(#00,#00), {  }
{  182} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,'|'),(#00,#00), {  }
{  188} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  194} (#00,#00),(#00,#00),(#00,'`'),(#00,#00),(#00,#00),(#00,#00), {  }
{  200} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,'`'), {  }
{  206} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  212} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  218} (#00,#00),(#0,#127),(#00,'_'),(#00,'{'),(#00,'}'),(#00,'~'), {  }
{  224} (#00,#00),('{',#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  230} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  236} (#00,#00),('>',#00),(#00,#00),(#00,#00),(#00,#00),('1',#00), {  }
{  242} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#56,#00),(#00,#00), {  }
{  248} ('0',#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  254} (#00,#00),(#00,#00) { $FF }
        );

procedure IbmVdt( var sour, dest : string );
var read  : word;
    write : word;
    c     : char;
    c2    : char;
begin
  read := 1;
  write := 0;
  while (read<=length(sour)) do
    begin
      c := sour[read];
      if c<' ' then
        begin
          if (c>=#24) and (c<=#27) then
            begin
              inc(write);
              dest[write] := #25;
              inc(write);
              dest[write] := TabInf32[byte(c)];
            end
          else
            if c=#21 then
              begin
                inc(write);
                dest[write] := #25;
                inc(write);
                dest[write] := #39;
              end;
        end
      else
        if c<#128 then
          begin
            inc(write);
            dest[write] := c;
          end
        else
          begin
            c2 := TabSup128[byte(c),1];
            if c2>#00 then
              begin
                inc(write);
                dest[write] := #25;
                inc(write);
                dest[write] := c2;
              end;
            c2 := TabSup128[byte(c),2];
            if c2>#00 then
              begin
                inc(write);
                dest[write] := c2;
              end;
          end;
      inc(read);
    end;
  dest[0] := char(write);
end;

procedure TradDataMntl ( car : char; var dest : string );
var s : string[1];
begin
  s[1] := car;
  s[0] := #01;
  IbmVdt(s,dest);
end;



procedure TradCar( car : char; Graph : boolean; var s : string );
begin
  if Graph then
   Begin
    car := Char((Byte(car) And 127) Or 32);
    If car=#127 Then car := #95;
    s := car;
   End
  Else TradDataMntl(car,s);
end;



procedure MoveCode( X,Y : byte; mode : byte; var Move : CMoveRec; var s : string );

  procedure MoveAs( How : ShortInt;
                    Code0, CodeCSI : char;
                    var result : string );
  var i : word;
      s : string[10];
  begin
    if How>=0 then for i := 1 to How do
                     begin
                       inc(result[0]);
                       result[length(result)] := Code0;
                     end
    else
      begin
        How := Abs(How);
        if How>1 then str(How,s) else s := '';
        inc(result[0]);
        result[length(result)] := #27;
        inc(result[0]);
        result[length(result)] := #91;
        for i := 1 to length(s) do
          begin
            inc(result[0]);
            result[length(result)] := s[i];
          end;
        inc(result[0]);
        result[length(result)] := CodeCSI;
      end;
  end;

var s2 : string[10];
    i  : word;
begin
  case Mode of
    BM_Norm   : begin { rien  faire }
                end;
    BM_13     : begin
                  inc(s[0]);
                  s[length(s)] := #13;
                end;
    BM_Home   : begin
                  inc(s[0]);
                  s[length(s)] := #30;
                end;
    BM_31     : begin
                  inc(s[0]);
                  s[length(s)] := #31;
                  inc(s[0]);
                  s[length(s)] := char(Y+64);
                  inc(s[0]);
                  s[length(s)] := char(X+65);
                end;
    BM_CSI_DIRECT :
      begin
        inc(s[0]);
        s[length(s)] := #27;
        inc(s[0]);
        s[length(s)] := #91;
        if Y>1 then
          begin
            str(Y,s2);
            for i := 1 to length(s2) do
              begin
                inc(s[0]);
                s[length(s)] := s2[i];
              end;
          end;
        if X>0 then
          begin
            inc(s[0]);
            s[length(s)] := ';';
            str(X+1,s2);
            for i := 1 to length(s2) do
              begin
                inc(s[0]);
                s[length(s)] := s2[i];
              end;
          end;
        inc(s[0]);
        s[length(s)] := 'H';
      end;
    BM_CSI_Home :
      begin
        inc(s[0]);
        s[length(s)] := #27;
        inc(s[0]);
        s[length(s)] := #91;
        inc(s[0]);
        s[length(s)] := 'H';
      end;
  end;
  if Move.How>0 then
    begin
      with Move do
        begin
          MoveAs(CLeft,#8,'D',s);
          MoveAs(CRight,#9,'C',s);
          MoveAs(CDown,#10,'B',s);
          MoveAs(CUp,#11,'A',s);
        end;
    end;
end;



procedure FlushRepet( var VD   : VDispRec;
                      X,Y      : byte;
                      Car      : char;
                      Att      : word;
                      var exr  : CResultRec;
                      var s    : string;
                      SelfCtrl : boolean );
var i,j    : word;
    x18    : word;
    Nb18   : word;
    Pos18X : byte;
    Pos18Y : byte;
    s2     : string[10];
    ROt    : CResultRec;
    R3X    : CResultRec;
    r      : CResultRec;
begin

  if VD.Wait.Nb<=0 then exit;

  if VD.Cfg.OptRepet then
    begin
      if (VD.Cfg.OptWithCan) and (VD.Wait.Car=#32) then
        begin
          if (VD.LastCar<>#32) or (VD.Cfg.xRep and not(VD.SpcDel)) then
            begin
              x18       := VD.Wait.Nb-1;
              Nb18      := 1+1+1;       { #32 #18 #Nb }
              Pos18X    := VD.Wait.X;
              Pos18Y    := VD.Wait.Y;
              NextCol(VD,Pos18X,Pos18Y,VD.Wait.CurAtt);
            end
          else
            begin
              x18       := VD.Wait.Nb;
              Nb18      := 1+1;       { #18+#Nb }
              Pos18X    := VD.Wait.X;
              Pos18Y    := VD.Wait.Y;
            end;

          { x18   = valeur du paramtre suivant #18 }
          { Nb18  = nombre de codes total pour le style REP }
          { NbCan = nombre de codes total pour le style CAN }

          if (VD.Wait.CurAtt and Large)<>0 then
            begin { double largeur }
              i := Pos18X+x18*2;
              if (i and 1<>0) and (i=ScreenLong+1) then i := ScreenLong;
            end
          else i := Pos18X+x18;

          if i=ScreenLong then
            begin { et CAN dans tous cela ! }

              if VD.Wait.CurAtt and Graphik<>0 then
                begin { mode graphik ... }
                  CChange(VD.Cfg,VD.Ram,X,Y,Car,Att,VD.Wait.CurAtt,rOt);
                  CChange(VD.Cfg,VD.Ram,X,Y,Car,Att,VD.Wait.CurAtt and
                          not(Graphik+Disjoint+Inverse+Taille+Fond)
                          or (Stable+Trait), { changement en cas de 31XY ou 30 }
                          r3X);

                  BestWay(VD.Cfg,VD.Wait.X,VD.Wait.Y,X,Y,rOt,r3X,r,FALSE);

                  if r.Total+1<exr.Total+Nb18 then
                    begin { CAN win ! }
                      inc(s[0]);
                      s[length(s)] := #24;
                      if not(SelfCtrl) and (r.Total>0) then
                        MoveCode(r.X,r.Y,r.Mode,r.Move,s);
                      exr        := r;
                      VD.Wait.Nb := 0;
                      VD.Cur.X   := VD.Wait.X; { peut tre superflu ... }
                      VD.Cur.Y   := VD.Wait.Y;
                      VD.Cur.Att := VD.Wait.CurAtt;
                      VD.SpcDel  := FALSE;
                      exit;
                    end;
                end
              else
                begin { mode texte }
                  CChange(VD.Cfg,VD.Ram,X,Y,Car,Att,VD.Wait.CurAtt,rOt);
                  CChange(VD.Cfg,VD.Ram,X,Y,Car,Att,VD.Wait.CurAtt and
                          not(Graphik+Disjoint+Inverse+Taille+Fond)
                          or (Stable+Trait), { changement en cas de 31XY ou 30 }
                          r3X);

                  BestWay(VD.Cfg,VD.Wait.X,VD.Wait.Y,X,Y,rOt,r3X,r,FALSE);

                  if r.Total+1<exr.Total+Nb18 then
                    begin
                      if (VD.Wait.X+1<ScreenLong) or
                         (VD.Wait.CurAtt and (Haut+Large)=0) then
                        begin
                          inc(s[0]);
                          s[length(s)] := #24;
                          if not(SelfCtrl) and (r.Total>0) then
                            MoveCode(r.X,r.Y,r.Mode,r.Move,s);
                          exr        := r;
                          VD.Wait.Nb := 0;
                          VD.Cur.X   := VD.Wait.X;     { peut tre superflu ... }
                          VD.Cur.Y   := VD.Wait.Y;
                          VD.Cur.Att := VD.Wait.CurAtt;
                          VD.SpcDel  := FALSE;
                          exit;
                        end;
                    end;
                end;
            end;
          s2 := ' ';
        end
      else TradCar(VD.Wait.Car,VD.Wait.CurAtt and Graphik<>0,s2);

      if (VD.LastCar<>VD.Wait.Car) or (VD.Cfg.xRep and not(VD.SpcDel)) then
        begin { c'est different ou on doit ecrire d'abord le car  repeter }
          VD.Wait.Nb := VD.Wait.Nb-1;
          VD.LastCar := VD.Wait.Car;
          for i := 1 to length(s2) do
            begin
              inc(s[0]);
              s[length(s)] := s2[i];
            end;
        end;

      if VD.Wait.Nb>0 then
        begin { a vider ... }
          if VD.Wait.Nb*length(s2)>2 then
            begin
              inc(s[0]);
              s[length(s)] := #18;
              inc(s[0]);
              s[length(s)] := char(VD.Wait.Nb+64);
            end
          else
            begin
              for i := 1 to VD.Wait.Nb do
                for j := 1 to length(s2) do
                  begin
                    inc(s[0]);
                    s[length(s)] := s2[j];
                  end;
            end;
          VD.Wait.Nb := 0;
        end;
    end
  else
    begin
      TradCar(VD.Wait.Car,VD.Wait.CurAtt and Graphik<>0,s2);
      for i := 1 to VD.Wait.Nb do
        for j := 1 to length(s2) do
          begin
            inc(s[0]);
            s[length(s)] := s2[j];
          end;
      VD.Wait.Nb := 0;
      VD.LastCar := VD.Wait.Car;
    end;
  VD.SpcDel := FALSE;
end;

procedure FlushTrans( var VD : VDispRec;
                      var s  : string );
var i,j : word;
    s2 : string[10];
begin
  s := '';

  if VD.Wait.Nb<=0 then exit;

  if VD.Cfg.OptRepet then
    begin
      if (VD.Wait.Car=#32) then
        begin
          if (VD.Wait.CurAtt and Large)<>0 then
            begin { double largeur }
              i := VD.Wait.X+VD.Wait.Nb*2;
              if (i and 1<>0) and (i=ScreenLong+1) then i := ScreenLong;
            end
          else i := VD.Wait.X+VD.Wait.Nb;
          if i=ScreenLong then
            begin
              if VD.Wait.Nb>1 then
                begin
                  inc(s[0]);
                  s[length(s)] := #24;
                  VD.Cur.X   := VD.Wait.X;
                  VD.Cur.Y   := VD.Wait.Y;   { normale, le deplacement n'a pas eu lieu ! }
                  VD.Cur.Att := VD.Wait.CurAtt;
                end
              else
                begin
                  inc(s[0]);
                  s[length(s)] := #32;
                  VD.LastCar := #32;
                end;
              VD.Wait.Nb := 0;
              VD.SpcDel  := FALSE;
              exit;
            end;
          s2 := ' ';  { la traduction est simple }
        end
      else TradCar(VD.Wait.Car,VD.Wait.CurAtt and Graphik<>0,s2);

      if (VD.LastCar<>VD.Wait.Car) or (VD.Cfg.xRep and not(VD.SpcDel)) then
        begin { c'est different }
          VD.Wait.Nb := VD.Wait.Nb-1;
          VD.LastCar := VD.Wait.Car;
          for i := 1 to length(s2) do
            begin
              inc(s[0]);
              s[length(s)] := s2[i];
            end;
        end;

      if VD.Wait.Nb>0 then
        begin { a vider ... }
          if VD.Wait.Nb*length(s2)>2 then
            begin
              inc(s[0]);
              s[length(s)] := #18;
              inc(s[0]);
              s[length(s)] := char(VD.Wait.Nb+64);
            end
          else
            begin
              for i := 1 to VD.Wait.Nb do
                for j := 1 to length(s2) do
                  begin
                    inc(s[0]);
                    s[length(s)] := s2[j];
                  end;
            end;
          VD.Wait.Nb := 0;
        end;
    end
  else
    begin
      TradCar(VD.Wait.Car,VD.Wait.CurAtt and Graphik<>0,s2);
      for i := 1 to VD.Wait.Nb do
        for j := 1 to length(s2) do
          begin
            inc(s[0]);
            s[length(s)] := s2[j];
          end;
      VD.Wait.Nb := 0;
      VD.LastCar := VD.Wait.Car;
    end;
  VD.SpcDel := FALSE;
end;


procedure AttCode( A, CA : word; var s : string );
const TabTrait : array[0..7] of char = ('@','D','A','E','B','F','C','G');
      TabFond  : array[0..7] of char = ('P','T','Q','U','R','V','S','W');
begin
  if CA and Graphik<>0 then
    begin { changement de jeu de caractre }
      if A and Graphik=0 then
        begin { texte }
          inc(s[0]);
          s[length(s)] := #15;
        end
      else
        begin { graphik }
          inc(s[0]);
          s[length(s)] := #14;
        end;
    end;
  if CA and Mask<>0 then
    begin { le mask change ! }
      inc(s[0]);
      s[length(s)] := #27;
      inc(s[0]);
      if A and Mask=0 then s[length(s)] := #95  { dmasquage }
      else s[length(s)] := #88;                 { masquage }
    end;
  if CA and Fond<>0 then
    begin { le fond change ! }
      inc(s[0]);
      s[length(s)] := #27;
      inc(s[0]);
      s[length(s)] := TabFond[(A and Fond) shr 3];
    end;
  if CA and Disjoint<>0 then
    begin { changement de soul }
      inc(s[0]);
      s[length(s)] := #27;
      inc(s[0]);
      if A and Disjoint=0 then s[length(s)] := #89  { fin lignage }
      else s[length(s)] := #90;                     { debut lignage }
    end;
  if CA and Trait<>0 then
    begin { changement de trait }
      inc(s[0]);
      s[length(s)] := #27;
      inc(s[0]);
      s[length(s)] := TabTrait[A and Trait];
    end;
  if CA and Stable<>0 then
    begin { changement stabilit }
      inc(s[0]);
      s[length(s)] := #27;
      inc(s[0]);
      if A and Stable=0 then s[length(s)] := #72  { clignotement }
      else s[length(s)] := #73;                   { fixe }
    end;
  if CA and Taille<>0 then
    begin { changement de taille }
      inc(s[0]);
      s[length(s)] := #27;
      inc(s[0]);
      s[length(s)] := char(((A and Taille) shr 6)+76);
    end;
  if CA and Inverse<>0 then
    begin
      inc(s[0]);
      s[length(s)] := #27;
      inc(s[0]);
      if A and Inverse=0 then s[length(s)] := #92  { fond normal }
      else s[length(s)] := #93;                    { inversion }
    end;
end;

procedure TransCode( var VD     : VDispRec;
                     X,Y        : byte;
                     Car        : char;
                     Att        : word;
                     var result : string );

var s : string;

var s2  : string[10];
    i   : word;
    rOt : CResultRec;
    r3X : CResultRec;
    r   : CResultRec;
    El  : PVDispRamEl;
label ici;
begin
  s := '';

  VD.NextLn := FALSE;  { remet  "zro" }

  if (Car=char(Complement)) then
    begin
      if X<=0 then El := nil else El := @VD.Ram^[Y,X-1];
      if VD.Cfg.ComplAsSpace and
         ((VD.Cfg.OptMem=OM_Nothing) or (VD.Ram^[Y,X].Car=#0)) and
         ((El=nil) or (El^.Car=char(Complement)) or (El^.Car=#0) or
          (El^.Att and Large=0)) then
         begin
           Car := #32;
           Att := VD.Cur.Att and not(Taille);
         end
      else Car := #0
    end
  else
    if (Car=#0) and VD.Cfg.VideAsSpace then
      begin
        Car := #32;
        Att := Graphik or (VD.Cur.Att and (Trait+Stable+Disjoint+Mask))
      end;

  if Car<>#0 then
    begin
      CChange(VD.Cfg,VD.Ram,X,Y,Car,Att,VD.Cur.Att,rOt);

      if (VD.Cur.X=X) and (VD.Cur.Y=Y) and (rOt.NbCA=0) then
        begin { Aucun changement de position ou d'attribut ! }
          if (VD.Cfg.OptMem=OM_All) and
             (VD.Ram^[rOt.Y,rOt.X].Car=rOt.Car) and
             (VD.Ram^[rOt.Y,rOt.X].Att=rOt.Att) then goto ici;
             { existe dj en Ram, donc ignore }

          r := rOt;
          if (VD.Wait.Nb>0) and (VD.Wait.Car=r.Car) then
            begin { y a une rptition qui se trame ... }
              if (VD.LastCar<>VD.Wait.Car) or (VD.Cfg.xRep and not(VD.SpcDel)) then i := 64
              else i := 63;
              inc(VD.Wait.Nb);
              if VD.Wait.Nb>=i then FlushRepet(VD,X,Y,Car,Att,r,s,FALSE);
            end
          else
            begin
              FlushRepet(VD,X,Y,Car,Att,r,s,FALSE);

              VD.Wait.Nb     := 1;
              VD.Wait.Car    := r.Car;
              VD.Wait.CurAtt := r.CurAtt;
              VD.Wait.X      := r.X;
              VD.Wait.Y      := r.Y;
            end;
        end
      else
        begin
          if (VD.Cfg.OptMem=OM_Some) and
             (VD.Ram^[rOt.Y,rOt.X].Car=rOt.Car) and
             (VD.Ram^[rOt.Y,rOt.X].Att=rOt.Att) then goto ici;
             { existe dj en Ram, donc ignore }

          CChange(VD.Cfg,VD.Ram,X,Y,Car,Att,VD.Cur.Att and
                  not(Graphik+Disjoint+Inverse+Taille+Fond)
                  or (Stable+Trait), { changement en cas de 31XY ou 30 }
                  r3X);

          BestWay(VD.Cfg,VD.Cur.X,VD.Cur.Y,X,Y,rOt,r3X,r,Not(VD.Cur.Rdy));
          VD.Cur.Rdy := TRUE;

          if r.Total>0 then
            begin { on doit forcement emettre les codes... }
              VD.SpcDel := FALSE;

              FlushRepet(VD,X,Y,Car,Att,r,s,TRUE);

              MoveCode(r.X,r.Y,r.Mode,r.Move,s);
              if r.NbCA>0 then AttCode(r.Att,r.CAtt,s);

              if (r.Att and Delim<>0) then
                begin { il s'agit d'un delimiteur }
                      { il faut l'envoyer sans attendre }
                  TradCar(r.Car,r.Att and Graphik<>0,s2);
                  for i := 1 to length(s2) do
                    begin
                      inc(s[0]);
                      s[length(s)] := s2[i];
                    end;
                  VD.Wait.Nb := 0;
                  VD.LastCar := r.Car;
                  VD.SpcDel  := TRUE;
                end
              else
                begin { mettre en attente pour voir la suite ... }
                  VD.Wait.Nb     := 1;
                  VD.Wait.Car    := r.Car;
                  VD.Wait.CurAtt := r.CurAtt;
                  VD.Wait.X      := r.X;
                  VD.Wait.Y      := r.Y;
                end;
            end
          else
            begin
              {$IFDEF DEBUG }
              writeln('BUG !');
              {$ENDIF }
            end;
        end;

      WriteVDRam(VD.Ram,r.X,r.Y,r.Car,r.Att);

      VD.Cur.X   := r.X;
      VD.Cur.Y   := r.Y;
      VD.Cur.Att := r.CurAtt;

      NextCol(VD,VD.Cur.X,VD.Cur.Y,VD.Cur.Att);

    end
  else
    begin { c'est rien ! }
  ici:
      FillChar(r,sizeof(r),0);

      r.X       := X;
      r.Y       := Y;
      r.Att     := AttNothing;
      r.Car     := #0;

      r.CurAtt  := VD.Cur.Att;
    end;

  result := s;
end;


procedure TransCodeScrollDown( var VD     : VDispRec;
                               var result : string );
var s   : string;
Begin
 FlushTrans(VD,s);

 If VD.Cur.Y>0 Then
  Begin
   s := s+#11;

   Dec(VD.Cur.Y);

   If VD.Cur.Y=0 then
    Begin
     ScrollDown(VD);
     VD.Cur.Y := 1;
    End;
  End;

 result := s;
End;


procedure TransCodeScrollUp( var VD     : VDispRec;
                             var result : string );
var s   : string;
Begin
 FlushTrans(VD,s);

 If VD.Cur.Y>0 Then
  Begin
   s := s+#10;
   Inc(VD.Cur.Y);

   If VD.Cur.Y>ScreenHigh-1 then
    Begin
     ScrollUp(VD);
     VD.Cur.Y := ScreenHigh-1;
    End;
  End;

 result := s;
End;


procedure ClearRam( Ram : PVDispRam );
var x, y : word;
begin
  if Ram<>nil then
    begin
      for y := 0 to ScreenHigh-1 do
        for x := 0 to ScreenLong-1 do
          with Ram^[y,x] do
            begin
              Car := #0;
              Att := AttNothing;
            end;
    end;
end;

procedure SetDefaultVD( var Cfg : VDispCfg );
begin
  Cfg := DefaultCfg;
end;

procedure InitVD( var VD : VDispRec );
{ on ne modifie pas Ram }
var Ram : PVDispRam;
begin
  Ram := VD.Ram; { sauve }
  FillChar(VD,sizeof(VD),0);
  VD.Cur.X   := 0;
  VD.Cur.Y   := 1;
  VD.Cur.Att := Trait+Stable;
  VD.Cur.Rdy := FALSE;

  VD.Cfg := DefaultCfg;
  VD.Ram := Ram; { restore }
end;


end.
